//
//  CatalogueControlViewController.m
//  plus
//
//  Created by Виктор Георгиев on 9/8/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#define NEW 0
#define PROMOTIONS 1
#define FAVOURITES 2
#define SHOPPING_CENTERS 3

#import "CatalogueControlViewController.h"
#import "PlaceViewController.h"

#import "Utils.h"

@interface CatalogueControlViewController ()

@property (strong, nonatomic) UINavigationController *catalogueNavigationController;

@end

@implementation CatalogueControlViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    if(self.catalogueType == NEW) {
        self.headerImageView.image = [UIImage imageNamed:@"menu_new"];
        self.headerLabel.text = [Utils translate:@"New"];
    } else if(self.catalogueType == PROMOTIONS) {
        self.headerImageView.image = [UIImage imageNamed:@"menu_promotions"];
        self.headerLabel.text = [Utils translate:@"Promotions"];
    } else if(self.catalogueType == FAVOURITES) {
        self.headerImageView.image = [UIImage imageNamed:@"menu_favourites"];
        self.headerLabel.text = [Utils translate:@"Favourites"];
    } else if(self.catalogueType == SHOPPING_CENTERS) {
        self.headerImageView.image = [UIImage imageNamed:@"menu_shopping_center"];
        self.headerLabel.text = [Utils translate:@"Shopping centers"];
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (IBAction)onBackPressed:(id)sender {
    if([self.catalogueNavigationController.viewControllers.lastObject isKindOfClass:[PlaceViewController class]]) {
        self.headerLabel.text = ((PlaceViewController *)self.catalogueNavigationController.viewControllers.lastObject).oldTitle;
    }
    
    if(self.catalogueNavigationController.viewControllers.count == 2) {
        if(self.catalogueType == NEW) {
            self.headerLabel.text = [Utils translate:@"New"];
        } else if(self.catalogueType == PROMOTIONS) {
            self.headerLabel.text = [Utils translate:@"Promotions"];
        } else if(self.catalogueType == FAVOURITES) {
            self.headerLabel.text = [Utils translate:@"Favourites"];
        } else if(self.catalogueType == SHOPPING_CENTERS) {
            self.headerLabel.text = [Utils translate:@"Shopping centers"];
        }
    }
    
    if(self.catalogueNavigationController.viewControllers.count == 1) {
        [self.navigationController popViewControllerAnimated:YES];
    } else {
        [self.catalogueNavigationController popViewControllerAnimated:YES];
    }
}

#pragma mark - Navigation

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    if([[segue destinationViewController] isKindOfClass:[UINavigationController class]]) {
        self.catalogueNavigationController = (UINavigationController *)[segue destinationViewController];
        ((CatalogueViewController *)[((UINavigationController *)[segue destinationViewController]).viewControllers objectAtIndex:0]).catalogueType = self.catalogueType;
        ((CatalogueViewController *)[((UINavigationController *)[segue destinationViewController]).viewControllers objectAtIndex:0]).catalogueControlViewController = self;
    }
}


@end
