//
//  CategoriesTableViewCell.m
//  plus
//
//  Created by Виктор Георгиев on 7/12/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "CategoriesTableViewCell.h"

#import "Utils.h"

@interface CategoriesTableViewCell()

@property (strong, nonatomic) UITapGestureRecognizer *tapRecognizer;

@end

@implementation CategoriesTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    self.tapRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(rippleEffect:)];
    self.tapRecognizer.cancelsTouchesInView = NO;
    [self.contentView addGestureRecognizer:self.tapRecognizer];
}

-(void)rippleEffect:(UITapGestureRecognizer *)tap {
    CGPoint point = [tap locationInView:self.contentView];
    CGFloat radius = 0;
    if(point.x > self.frame.size.width - point.x) {
        radius = point.x;
    } else {
        radius = self.frame.size.width - point.x;
    }
    CAShapeLayer *shape = [[CAShapeLayer alloc] init];
    shape.frame = self.contentView.bounds;
    UIBezierPath *fromPath = [UIBezierPath bezierPathWithOvalInRect:CGRectMake(point.x - 0.1, point.y - 0.1, 0.2, 0.2)];
    UIBezierPath *toPath = [UIBezierPath bezierPathWithOvalInRect:CGRectMake(point.x - radius, point.y - radius, radius * 2, radius * 2)];
    [shape setFillColor:[Utils colorFromHexString:@"#7F41A2BA"].CGColor];
    [self.contentView.layer addSublayer:shape];
    CABasicAnimation *anim = [CABasicAnimation animationWithKeyPath:@"path"];
    anim.fromValue = (id)fromPath.CGPath;
    anim.toValue = (id)toPath.CGPath;
    anim.duration = 0.5;
    
    CABasicAnimation *fade = [CABasicAnimation  animationWithKeyPath:@"opacity"];
    fade.fromValue = [NSNumber numberWithFloat:1.0];
    fade.toValue = [NSNumber numberWithFloat:0.0];
    fade.duration = 0.25;
    fade.beginTime = CACurrentMediaTime() + 0.25;
    
    [shape addAnimation:anim forKey:@"anim"];
    [shape addAnimation:fade forKey:@"fade"];
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];
}

@end
