//
//  DebitCardViewController.m
//  plus
//
//  Created by Виктор Георгиев on 7/22/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//
#define kOFFSET_FOR_KEYBOARD 80.0

#import "DebitCardViewController.h"
#import "DatePickerDialogViewController.h"
#import "Utils.h"

@interface DebitCardViewController ()

@property (assign, nonatomic) int currentPage;
@property (assign, nonatomic) BOOL hasAnimated;

@property (weak, nonatomic) IBOutlet UILabel *customerProtectionLabel;

@property (weak, nonatomic) IBOutlet UIView *firstCircleView;
@property (weak, nonatomic) IBOutlet UILabel *firstCircleNumber;

@property (weak, nonatomic) IBOutlet UIView *secondCircleView;
@property (weak, nonatomic) IBOutlet UILabel *secondCircleNumber;

@property (weak, nonatomic) IBOutlet UIView *thirdCircleView;
@property (weak, nonatomic) IBOutlet UILabel *thirdCircleNumber;

@property (weak, nonatomic) IBOutlet UIScrollView *requestDebitCardScrollView;
@property (weak, nonatomic) IBOutlet UIScrollView *cardInformationScrollView;

@property (weak, nonatomic) IBOutlet UIView *bgnCircleView;
@property (weak, nonatomic) IBOutlet UIView *eurCircleView;
@property (weak, nonatomic) IBOutlet UIView *usdCircleView;

@property (weak, nonatomic) IBOutlet UIButton *forwardAndSendButton;
@property (weak, nonatomic) IBOutlet UIButton *backwardButton;

@property (strong, nonatomic) NSArray<UIView *> *viewsArray;
@property (assign, nonatomic) int datePickerPlaceSelected;
@property (assign, nonatomic) int datePickerOption;
@property (strong, nonatomic) NSDate *date;

@property (weak, nonatomic) IBOutlet UITextField *nameAndLastnameTextField;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *nameAndLastNameHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *nameAndLastNameErrorViewConstraint;
@property (weak, nonatomic) IBOutlet UIImageView *nameAndLastNameErrorImage;

@property (weak, nonatomic) IBOutlet UITextField *nameSurnameLastnameTextField;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *nameSurnameLastnameHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *nameSurnameLastnameErrorViewConstraint;
@property (weak, nonatomic) IBOutlet UIImageView *nameSurnameLastnameErrorImage;

@property (weak, nonatomic) IBOutlet UIView *birthDateView;
@property (weak, nonatomic) IBOutlet UILabel *birthDateLabel;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *birthDateViewHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *birthDateErrorViewConstraint;
@property (weak, nonatomic) IBOutlet UIImageView *birthDateErrorImage;

@property (weak, nonatomic) IBOutlet UITextField *idCardNumberTextField;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *idCardNumberHeighConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *idCardNumberErrorViewConstraint;
@property (weak, nonatomic) IBOutlet UIImageView *idCardNumberErrorImage;

@property (weak, nonatomic) IBOutlet UIView *idDateCreatedView;
@property (weak, nonatomic) IBOutlet UILabel *idDateCreatedLabel;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *idDateCreatedViewHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *idDateCreatedErrorViewConstraint;
@property (weak, nonatomic) IBOutlet UIImageView *idDateCreatedErrorImage;

@property (weak, nonatomic) IBOutlet UITextField *idIssuerTextField;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *idIssuerTextFieldHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *idIssuerErrorViewConstraint;
@property (weak, nonatomic) IBOutlet UIImageView *idIssuerErrorImage;

@property (weak, nonatomic) IBOutlet UITextField *idCityTextField;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *idCityTextFieldHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *idCityErrorViewConstraint;
@property (weak, nonatomic) IBOutlet UIImageView *idCityErrorImage;

@property (weak, nonatomic) IBOutlet UITextField *idPostalCodeTextField;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *idPostalCodeTextFieldHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *idPostalCodeErrorViewConstraint;
@property (weak, nonatomic) IBOutlet UIImageView *idPostalCodeErrorImage;

@property (weak, nonatomic) IBOutlet UITextField *idAddressTextField;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *idAddressTextFieldHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *idAddressErrorViewConstraint;
@property (weak, nonatomic) IBOutlet UIImageView *idAddressErrorImage;

@property (weak, nonatomic) IBOutlet UITextField *clientPhoneNumberTextField;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *clientPhoneNumberTextFieldHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *clientPhoneNumberErrorViewConstraint;
@property (weak, nonatomic) IBOutlet UIImageView *clientPhoneNumberErrorImage;

@property (weak, nonatomic) IBOutlet UITextField *clientEmailAddressTextField;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *clientEmailAddressTextFieldHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *clientEmailAddressErrorViewConstraint;
@property (weak, nonatomic) IBOutlet UIImageView *clientEmailAddressErrorImage;

@property (weak, nonatomic) IBOutlet UIView *clientPreferedTimeView;
@property (weak, nonatomic) IBOutlet UILabel *clientPreferedTimeLabel;

@end

@implementation DebitCardViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.hasAnimated = NO;
    self.viewsArray = @[self.nameAndLastnameTextField, self.nameSurnameLastnameTextField, self.birthDateLabel, self.idCardNumberTextField, self.idDateCreatedLabel, self.idIssuerTextField, self.idCityTextField, self.idPostalCodeTextField, self.idAddressTextField, self.clientPhoneNumberTextField, self.clientEmailAddressTextField];
    self.customerProtectionLabel.text = [Utils translate:@"Customer Protection"];
    
    [self clearFocusedCircleView:self.secondCircleView andCircleNumber:self.secondCircleNumber];
    [self clearFocusedCircleView:self.thirdCircleView andCircleNumber:self.thirdCircleNumber];
    
    [self setCurrencyBorderColor:self.bgnCircleView];
    [self setCurrencyBorderColor:self.eurCircleView];
    [self setCurrencyBorderColor:self.usdCircleView];
    
    self.nameAndLastnameTextField.tag = 100;
    
    self.nameSurnameLastnameTextField.tag = 200;
    self.birthDateLabel.tag = 201;
    [self customizeView:self.birthDateView];
    self.idCardNumberTextField.tag = 202;
    self.idDateCreatedLabel.tag = 203;
    [self customizeView:self.idDateCreatedView];
    self.idIssuerTextField.tag = 204;
    self.idCityTextField.tag = 205;
    self.idPostalCodeTextField.tag = 206;
    self.idAddressTextField.tag = 207;
    
    self.clientPhoneNumberTextField.tag = 300;
    self.clientEmailAddressTextField.tag = 301;
    
    [self customizeView:self.clientPreferedTimeView];
    
    for(UIView *view in self.viewsArray) {
        if([view isKindOfClass:[UITextField class]]) {
            [self customizeView:view];
        }
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView {
    int page = (scrollView.contentOffset.x + scrollView.frame.size.width / 2) / scrollView.frame.size.width;
    [self changePage:page];
    self.currentPage = page;
}

-(void)changePage:(int)page {
    switch (page) {
        case 0: {
            [self setFocusedCircleView:self.firstCircleView andCircleNumber:self.firstCircleNumber];
            [self clearFocusedCircleView:self.secondCircleView andCircleNumber:self.secondCircleNumber];
            [self clearFocusedCircleView:self.thirdCircleView andCircleNumber:self.thirdCircleNumber];
            [self.backwardButton setHidden:YES];
            break;
        }
            
        case 1: {
            [self clearFocusedCircleView:self.firstCircleView andCircleNumber:self.firstCircleNumber];
            [self setFocusedCircleView:self.secondCircleView andCircleNumber:self.secondCircleNumber];
            [self clearFocusedCircleView:self.thirdCircleView andCircleNumber:self.thirdCircleNumber];
            [self.backwardButton setHidden:NO];
            [self.forwardAndSendButton setTitle:@"Напред" forState:UIControlStateNormal];
            break;
        }
            
        case 2: {
            [self clearFocusedCircleView:self.firstCircleView andCircleNumber:self.firstCircleNumber];
            [self clearFocusedCircleView:self.secondCircleView andCircleNumber:self.secondCircleNumber];
            [self setFocusedCircleView:self.thirdCircleView andCircleNumber:self.thirdCircleNumber];
            [self.forwardAndSendButton setTitle:@"Заяви сега" forState:UIControlStateNormal];
            break;
        }
    }
}

-(void)clearFocusedCircleView:(UIView *)circleView andCircleNumber:(UILabel *)circleNumber {
    CGFloat borderRadius = 2;
    UIColor *borderColor = [UIColor colorWithRed:231 / 255.0 green:231 / 255.0 blue:231 / 255.0 alpha:1];
    circleView.backgroundColor = [UIColor whiteColor];
    circleView.layer.borderWidth = borderRadius;
    circleView.layer.borderColor = borderColor.CGColor;
    circleNumber.textColor = [UIColor colorWithRed:117 / 255.0 green:117 / 255.0 blue:117 / 255.0 alpha:1];
}

-(void)setFocusedCircleView:(UIView *)circleView andCircleNumber:(UILabel *)circleNumber {
    circleView.backgroundColor = [UIColor colorWithRed:70 / 255.0 green:174 / 255.0 blue:199 / 255.0 alpha:1];
    circleView.layer.borderWidth = 0;
    circleNumber.textColor = [UIColor whiteColor];
}

-(void)setCurrencyBorderColor:(UIView *)circleView{
    circleView.layer.borderWidth = 2;
    circleView.layer.borderColor = [UIColor colorWithRed:68 / 255.0 green:172 / 255.0 blue:197 / 255.0 alpha:1].CGColor;
    circleView.backgroundColor = [UIColor whiteColor];
}

-(void)customizeView:(UIView *)view {
    view.layer.cornerRadius = 5;
    view.layer.borderWidth = 1;
    view.layer.borderColor = [UIColor colorWithRed:204 / 255.0 green:204 / 255.0 blue:204 / 255.0 alpha:1].CGColor;
}

-(void)setTextFieldImage:(UITextField *)textField withName:(NSString *)imageName {
    UIImageView *imageView = [[UIImageView alloc] initWithFrame:CGRectMake(10, 10, 20, 20)];
    imageView.image = [UIImage imageNamed:imageName];
    imageView.backgroundColor = [UIColor grayColor];
    textField.leftView = imageView;
}

-(void)animatePageChange:(int)page {
    [UIView animateWithDuration:0.3 animations:^{
        [self.requestDebitCardScrollView setContentOffset:CGPointMake(page * self.requestDebitCardScrollView.frame.size.width, 0)];
    }];
}

- (IBAction)onFirstPageTap:(id)sender {
    [self animatePageChange:0];
}

- (IBAction)onSecondPageTap:(id)sender {
    [self animatePageChange:1];
}

- (IBAction)onThirdPageTap:(id)sender {
    [self animatePageChange:2];
}

- (IBAction)onBGNTap:(id)sender {
    self.bgnCircleView.backgroundColor = [UIColor colorWithRed:68 / 255.0 green:172 / 255.0 blue:197 / 255.0 alpha:1];
    [self setCurrencyBorderColor:self.eurCircleView];
    [self setCurrencyBorderColor:self.usdCircleView];
}
- (IBAction)onEURTap:(id)sender {
    [self setCurrencyBorderColor:self.bgnCircleView];
    self.eurCircleView.backgroundColor = [UIColor colorWithRed:68 / 255.0 green:172 / 255.0 blue:197 / 255.0 alpha:1];
    [self setCurrencyBorderColor:self.usdCircleView];
}

- (IBAction)onUSDTap:(id)sender {
    [self setCurrencyBorderColor:self.bgnCircleView];
    [self setCurrencyBorderColor:self.eurCircleView];
    self.usdCircleView.backgroundColor = [UIColor colorWithRed:68 / 255.0 green:172 / 255.0 blue:197 / 255.0 alpha:1];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 0;
}

- (IBAction)onBirthDateTap:(id)sender {
    self.datePickerOption = 0;
    self.datePickerPlaceSelected = 0;
    [self performSegueWithIdentifier:@"DatePickerSegue" sender:self];
}

- (IBAction)onIdIssuedTap:(id)sender {
    self.datePickerOption = 0;
    self.datePickerPlaceSelected = 1;
    [self performSegueWithIdentifier:@"DatePickerSegue" sender:self];
}

- (IBAction)onPreferedTimeTap:(id)sender {
    self.datePickerOption = 1;
    [self performSegueWithIdentifier:@"DatePickerSegue" sender:self];
}

- (IBAction)onBackwardPressed:(id)sender {
    if(self.currentPage > 0) {
        self.currentPage--;
        [self changePage:self.currentPage];
        [self animatePageChange:self.currentPage];
    }
}

- (IBAction)onForwardPressed:(id)sender {
    if(self.currentPage < 2) {
        self.currentPage++;
        [self changePage:self.currentPage];
        [self animatePageChange:self.currentPage];
    } else if(self.currentPage == 2) {
        int jumpToPage = 2;
        for(UIView *view in self.viewsArray) {
            int page = (int) view.tag / 100;
            if([view isKindOfClass:[UITextField class]]) {
                if(((UITextField *)view).text.length == 0) {
                    if((page - 1) < jumpToPage) {
                        jumpToPage = page;
                    }
                }
                [self errorViewControl:(UITextField *)view withLabel:nil];
            } else if([view isKindOfClass:[UILabel class]]) {
                if(((UILabel *)view).text.length == 0) {
                    if((page - 1) < jumpToPage) {
                        jumpToPage = page;
                    }
                }
                [self errorViewControl:nil withLabel:(UILabel *)view];
            }
        }
        self.currentPage = jumpToPage - 1;
        [self changePage:self.currentPage];
        [self animatePageChange:self.currentPage];
    }
}

-(void)textFieldDidBeginEditing:(UITextField *)textField {
    CGPoint textFieldPoint = [textField convertPoint:[textField bounds].origin toView:nil];
    CGRect screen = [[UIScreen mainScreen] bounds];
    if((screen.size.height - textFieldPoint.y) <= 216) {
        [self animateTextField:textField up:YES];
        self.hasAnimated = YES;
    }
}

- (void)textFieldDidEndEditing:(UITextField *)textField {
    if(self.hasAnimated) {
        [self animateTextField:textField up:NO];
        self.hasAnimated = NO;
    }
    [self errorViewControl:textField withLabel:nil];
}

-(void)errorViewControl:(UITextField *)textField withLabel:(UILabel *)textLabel {
    if(textField != nil) {
        switch(textField.tag) {
            case 100: {
                [self showErrorView:textField withErrorImage:self.nameAndLastNameErrorImage andHeightConstraint:self.nameAndLastNameHeightConstraint andErrorHeightConstraint:self.nameAndLastNameErrorViewConstraint];
                break;
            }
                
            case 200: {
                [self showErrorView:textField withErrorImage:self.nameSurnameLastnameErrorImage andHeightConstraint:self.nameSurnameLastnameHeightConstraint andErrorHeightConstraint:self.nameSurnameLastnameErrorViewConstraint];
                break;
            }
                
            case 202: {
                [self showErrorView:textField withErrorImage:self.idCardNumberErrorImage andHeightConstraint:self.idCardNumberHeighConstraint andErrorHeightConstraint:self.idCardNumberErrorViewConstraint];
                break;
            }
                
            case 204: {
                [self showErrorView:textField withErrorImage:self.idIssuerErrorImage andHeightConstraint:self.idIssuerTextFieldHeightConstraint andErrorHeightConstraint:self.idIssuerErrorViewConstraint];
                break;
            }
                
            case 205: {
                [self showErrorView:textField withErrorImage:self.idCityErrorImage andHeightConstraint:self.idCityTextFieldHeightConstraint andErrorHeightConstraint:self.idCityErrorViewConstraint];
                break;
            }
                
            case 206: {
                [self showErrorView:textField withErrorImage:self.idPostalCodeErrorImage andHeightConstraint:self.idPostalCodeTextFieldHeightConstraint andErrorHeightConstraint:self.idPostalCodeErrorViewConstraint];
                break;
            }
                
            case 207: {
                [self showErrorView:textField withErrorImage:self.idAddressErrorImage andHeightConstraint:self.idAddressTextFieldHeightConstraint andErrorHeightConstraint:self.idAddressErrorViewConstraint];
                break;
            }
                
            case 300: {
                [self showErrorView:textField withErrorImage:self.clientPhoneNumberErrorImage andHeightConstraint:self.clientPhoneNumberTextFieldHeightConstraint andErrorHeightConstraint:self.clientPhoneNumberErrorViewConstraint];
                break;
            }
                
            case 301: {
                [self showErrorView:textField withErrorImage:self.clientEmailAddressErrorImage andHeightConstraint:self.clientEmailAddressTextFieldHeightConstraint andErrorHeightConstraint:self.clientEmailAddressErrorViewConstraint];
                break;
            }
        }
    } else if(textLabel != nil) {
        switch (textLabel.tag) {
            case 201: {
                if(textLabel.text.length == 0) {
                    [self showErrorView:self.birthDateView withErrorImage:self.birthDateErrorImage andHeightConstraint:self.birthDateViewHeightConstraint andErrorHeightConstraint:self.birthDateErrorViewConstraint];
                } else {
                    [self hideErrorView:self.birthDateView withErrorImage:self.birthDateErrorImage andHeightConstraint:self.birthDateViewHeightConstraint andErrorHeightConstraint:self.birthDateErrorViewConstraint];
                }
                break;
            }
                
            case 203: {
                if(textLabel.text.length == 0) {
                    [self showErrorView:self.idDateCreatedView withErrorImage:self.idDateCreatedErrorImage andHeightConstraint:self.idDateCreatedViewHeightConstraint andErrorHeightConstraint:self.idDateCreatedErrorViewConstraint];
                } else {
                    [self hideErrorView:self.idDateCreatedView withErrorImage:self.idDateCreatedErrorImage andHeightConstraint:self.idDateCreatedViewHeightConstraint andErrorHeightConstraint:self.idDateCreatedErrorViewConstraint];
                }
                break;
            }
        }
    }
}

-(void)showErrorView:(UIView *)textField withErrorImage:(UIImageView* )errorImageView andHeightConstraint:(NSLayoutConstraint *)heightConstraint andErrorHeightConstraint:(NSLayoutConstraint *)errorHeighConstraint  {
    if([textField isKindOfClass:[UITextField class]]) {
        if(((UITextField *)textField).text.length == 0) {
            textField.layer.borderColor = [UIColor colorWithRed:232 / 255.0 green:28 / 255.0 blue:37 / 255.0 alpha:1].CGColor;
            [errorImageView setHidden:NO];
            heightConstraint.constant = 80;
            errorHeighConstraint.constant = 80;
        } else {
            [self hideErrorView:textField withErrorImage:errorImageView andHeightConstraint:heightConstraint andErrorHeightConstraint:errorHeighConstraint];
        }
    } else {
        textField.layer.borderColor = [UIColor colorWithRed:232 / 255.0 green:28 / 255.0 blue:37 / 255.0 alpha:1].CGColor;
        [errorImageView setHidden:NO];
        heightConstraint.constant = 80;
        errorHeighConstraint.constant = 80;
    }
}

-(void)hideErrorView:(UIView *)textField withErrorImage:(UIImageView* )errorImageView andHeightConstraint:(NSLayoutConstraint *)heightConstraint andErrorHeightConstraint:(NSLayoutConstraint *)errorHeighConstraint  {
    textField.layer.borderColor = [UIColor colorWithRed:204 / 255.0 green:204 / 255.0 blue:204 / 255.0 alpha:1].CGColor;
    [errorImageView setHidden:YES];
    heightConstraint.constant = 40;
    errorHeighConstraint.constant = 0;
}

-(void)animateTextField:(UITextField*)textField up:(BOOL)up {
    const int movementDistance = -130;
    const float movementDuration = 0.3f;
    
    int movement = (up ? movementDistance : -movementDistance);
    
    [UIView beginAnimations: @"animateTextField" context: nil];
    [UIView setAnimationBeginsFromCurrentState: YES];
    [UIView setAnimationDuration: movementDuration];
    self.view.frame = CGRectOffset(self.view.frame, 0, movement);
    [UIView commitAnimations];
}

-(BOOL)textFieldShouldReturn:(UITextField *)textField {    
    [textField resignFirstResponder];
    return NO;
}

- (IBAction)onBackPressed:(id)sender {
    [self.navigationController popViewControllerAnimated:YES];
}

#pragma mark - Navigation

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    DatePickerDialogViewController *dialogDatePicker = [segue destinationViewController];
    dialogDatePicker.datePickerOption = [NSNumber numberWithInt:self.datePickerOption];
    dialogDatePicker.onDismiss = ^(NSDate *date) {
        self.date = date;
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        if(self.datePickerOption == 0) {
            if(self.datePickerPlaceSelected == 0) {
                dateFormatter.dateFormat = @"dd.MM.yyyy";
                NSString *dateString = [dateFormatter stringFromDate:date];
                self.birthDateLabel.text = dateString;
                [self hideErrorView:self.birthDateView withErrorImage:self.birthDateErrorImage andHeightConstraint:self.birthDateViewHeightConstraint andErrorHeightConstraint:self.birthDateErrorViewConstraint];
            } else if(self.datePickerPlaceSelected == 1) {
                dateFormatter.dateFormat = @"dd.MM.yyyy";
                NSString *dateString = [dateFormatter stringFromDate:date];
                self.idDateCreatedLabel.text = dateString;
                [self hideErrorView:self.idDateCreatedView withErrorImage:self.idDateCreatedErrorImage andHeightConstraint:self.idDateCreatedViewHeightConstraint andErrorHeightConstraint:self.idDateCreatedErrorViewConstraint];
            }
        } else if(self.datePickerOption == 1) {
            dateFormatter.dateFormat = @"HH:mm";
            NSString *timeString = [dateFormatter stringFromDate:date];
            self.clientPreferedTimeLabel.text = timeString;
        }
    };
}


@end
