//
//  ErrorViewController.m
//  plus
//
//  Created by Виктор Георгиев on 9/21/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "ErrorViewController.h"

#import "Utils.h"

@interface ErrorViewController ()

@property (weak, nonatomic) IBOutlet UILabel *errorLabel;
@property (weak, nonatomic) IBOutlet UILabel *errorSolutionLabel;

@property (weak, nonatomic) IBOutlet UIButton *exitButton;
@property (weak, nonatomic) IBOutlet UIButton *tryAgainButton;

@end

@implementation ErrorViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.errorLabel.text = [Utils translate:@"Error"];
    self.errorSolutionLabel.text = [Utils translate:@"Error solution"];
    
    [self.exitButton setTitle:[Utils translate:@"Exit"] forState:UIControlStateNormal];
    [self.tryAgainButton setTitle:[Utils translate:@"Try again"] forState:UIControlStateNormal];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (IBAction)onExitPressed:(id)sender {
    exit(0);
}

- (IBAction)onTryAgainPressed:(id)sender {
    if([Utils deviceHasInternetConneciton]) {
        self.onDismiss();
        [self dismissViewControllerAnimated:NO completion:nil];
    }
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
