//
//  GalleryViewController.m
//  plus
//
//  Created by Виктор Георгиев on 8/17/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "GalleryViewController.h"

#import "Utils.h"

@interface GalleryViewController ()

@property (weak, nonatomic) IBOutlet UIScrollView *galleryScrollView;

@property (weak, nonatomic) IBOutlet UIButton *backButton;
@property (weak, nonatomic) IBOutlet UIButton *crossBackButton;

@property (assign, nonatomic) BOOL didLayoutSubviews;

@end

@implementation GalleryViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.didLayoutSubviews = NO;
    
    if(self.isFromMainDrawer) {
        self.backButton.userInteractionEnabled = YES;
    } else {
        self.crossBackButton.hidden = YES;
    }
}

-(void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    if(!self.isFromMainDrawer) {
        CGRect rect = self.backButton.bounds;
        UIBezierPath *maskPath = [UIBezierPath bezierPathWithRoundedRect:rect byRoundingCorners:UIRectCornerTopRight cornerRadii:CGSizeMake(10, 10)];
        CAShapeLayer *maskLayer = [CAShapeLayer layer];
        maskLayer.fillColor = [Utils colorFromHexString:@"#46ADC6"].CGColor;
        maskLayer.frame = rect;
        maskLayer.path = maskPath.CGPath;
        [self.backButton.layer insertSublayer:maskLayer atIndex:0];
        self.backButton.hidden = NO;
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

-(void)viewDidLayoutSubviews {
    if(!self.didLayoutSubviews) {
        for(int i = 0; i < self.imagesArray.count; i++) {
            CGRect frame;
            frame.origin.x = self.galleryScrollView.frame.size.width * i;
            frame.origin.y = 0;
            frame.size = self.galleryScrollView.frame.size;
            
            UIImageView *imageView = [[UIImageView alloc] initWithFrame:frame];
            imageView.image = [self.imagesArray objectAtIndex:i];
            imageView.contentMode = UIViewContentModeScaleAspectFit;
            
            [self.galleryScrollView addSubview:imageView];
            
            self.galleryScrollView.contentSize = CGSizeMake(self.galleryScrollView.frame.size.width * (i + 1), self.galleryScrollView.frame.size.height);
        }
        
        [self.galleryScrollView setContentOffset:CGPointMake(self.currentPage * self.galleryScrollView.frame.size.width, 0)];
        self.didLayoutSubviews = YES;
    }
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView {
    self.currentPage = (scrollView.contentOffset.x + scrollView.frame.size.width / 2) / scrollView.frame.size.width;
}

- (IBAction)onBackPressed:(id)sender {
    self.onDismiss(self.currentPage);
    [self dismissViewControllerAnimated:YES completion:nil];
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
