//
//  LoadAnimationViewController.m
//  plus
//
//  Created by Виктор Георгиев on 7/20/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "LoadAnimationViewController.h"

#import "Utils.h"

@interface LoadAnimationViewController ()

@property (weak, nonatomic) IBOutlet UIView *firstView;
@property (weak, nonatomic) IBOutlet UIView *secondView;
@property (weak, nonatomic) IBOutlet UIView *thirdView;
@property (weak, nonatomic) IBOutlet UIView *fourthView;

@property (weak, nonatomic) IBOutlet NSLayoutConstraint *firstViewCenterConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *secondViewCenterConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *thirdViewCenterConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *fourthViewCenterConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *animationHolderViewCenterConstraint;

@property (strong, nonatomic) UIColor *firstColor;
@property (strong, nonatomic) UIColor *secondColor;
@property (strong, nonatomic) UIColor *thirdColor;
@property (strong, nonatomic) UIColor *fourthColor;

@end

@implementation LoadAnimationViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.firstColor = [Utils colorFromHexString:@"#ffffff"];
    self.secondColor = [Utils colorFromHexString:@"#91def1"];
    self.thirdColor = [Utils colorFromHexString:@"#e0e0e0"];
    self.fourthColor = [Utils colorFromHexString:@"#91f1e0"];
    
    if(self.isInitialLaunch) {
        self.animationHolderViewCenterConstraint.constant = [UIScreen mainScreen].bounds.size.height / 4;
        self.view.backgroundColor = [UIColor clearColor];
    }
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];

    NSTimer *timer = [NSTimer scheduledTimerWithTimeInterval:0.2 target:self selector:@selector(newTimer) userInfo:nil repeats:NO];
    [timer fire];
}

- (void)newTimer {
    NSTimer *timer = [NSTimer scheduledTimerWithTimeInterval:1.433 target:self selector:@selector(startAnimation) userInfo:nil repeats:YES];
    [timer fire];
}

- (void)startAnimation {
    dispatch_async(dispatch_get_main_queue(), ^{
        
    [self.view layoutIfNeeded];
    [UIView animateWithDuration:0.4299 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
        self.firstViewCenterConstraint.constant -= 5;
        [self.view layoutIfNeeded];
    } completion:^(BOOL finished) {
        self.firstView.backgroundColor = self.secondColor;
        [self.view layoutIfNeeded];
        [UIView animateWithDuration:0.2866 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
            self.firstViewCenterConstraint.constant += 5;
            [self.view layoutIfNeeded];
        } completion:^(BOOL finished) {
            self.firstView.backgroundColor = self.thirdColor;
            [self.view layoutIfNeeded];
            [UIView animateWithDuration:0.2866 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
                self.firstViewCenterConstraint.constant += 5;
                [self.view layoutIfNeeded];
            } completion:^(BOOL finished) {
                self.firstView.backgroundColor = self.fourthColor;
                [self.view layoutIfNeeded];
                [UIView animateWithDuration:0.4299 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
                    self.firstViewCenterConstraint.constant -= 5;
                    [self.view layoutIfNeeded];
                } completion:^(BOOL finished) {
                    self.firstView.backgroundColor = self.firstColor;
                }];
            }];
        }];
    }];
    
    [self.view layoutIfNeeded];
    [UIView animateWithDuration:0.4299 delay:0.1875 options:UIViewAnimationOptionCurveLinear animations:^{
        self.secondViewCenterConstraint.constant -= 5;
        [self.view layoutIfNeeded];
    } completion:^(BOOL finished) {
        self.secondView.backgroundColor = self.secondColor;
        [self.view layoutIfNeeded];
        [UIView animateWithDuration:0.2866 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
            self.secondViewCenterConstraint.constant += 5;
            [self.view layoutIfNeeded];
        } completion:^(BOOL finished) {
            self.secondView.backgroundColor = self.thirdColor;
            [self.view layoutIfNeeded];
            [UIView animateWithDuration:0.2866 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
                self.secondViewCenterConstraint.constant += 5;
                [self.view layoutIfNeeded];
            } completion:^(BOOL finished) {
                self.secondView.backgroundColor = self.fourthColor;
                [self.view layoutIfNeeded];
                [UIView animateWithDuration:0.4299 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
                    self.secondViewCenterConstraint.constant -= 5;
                    [self.view layoutIfNeeded];
                } completion:^(BOOL finished) {
                    self.secondView.backgroundColor = self.firstColor;
                }];
            }];
        }];
    }];
    
    [self.view layoutIfNeeded];
    [UIView animateWithDuration:0.4299 delay:0.375 options:UIViewAnimationOptionCurveLinear animations:^{
        self.thirdViewCenterConstraint.constant -= 5;
        [self.view layoutIfNeeded];
    } completion:^(BOOL finished) {
        self.thirdView.backgroundColor = self.secondColor;
        [self.view layoutIfNeeded];
        [UIView animateWithDuration:0.2866 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
            self.thirdViewCenterConstraint.constant += 5;
            [self.view layoutIfNeeded];
        } completion:^(BOOL finished) {
            self.thirdView.backgroundColor = self.thirdColor;
            [self.view layoutIfNeeded];
            [UIView animateWithDuration:0.2866 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
                self.thirdViewCenterConstraint.constant += 5;
                [self.view layoutIfNeeded];
            } completion:^(BOOL finished) {
                self.thirdView.backgroundColor = self.fourthColor;
                [self.view layoutIfNeeded];
                [UIView animateWithDuration:0.4299 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
                    self.thirdViewCenterConstraint.constant -= 5;
                    [self.view layoutIfNeeded];
                } completion:^(BOOL finished) {
                    self.thirdView.backgroundColor = self.firstColor;
                }];
            }];
        }];
    }];
    
    [self.view layoutIfNeeded];
    [UIView animateWithDuration:0.4299 delay:0.5625 options:UIViewAnimationOptionCurveLinear animations:^{
        self.fourthViewCenterConstraint.constant -= 5;
        [self.view layoutIfNeeded];
    } completion:^(BOOL finished) {
        self.fourthView.backgroundColor = self.secondColor;
        [self.view layoutIfNeeded];
        [UIView animateWithDuration:0.2866 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
            self.fourthViewCenterConstraint.constant += 5;
            [self.view layoutIfNeeded];
        } completion:^(BOOL finished) {
            self.fourthView.backgroundColor = self.thirdColor;
            [self.view layoutIfNeeded];
            [UIView animateWithDuration:0.2866 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
                self.fourthViewCenterConstraint.constant += 5;
                [self.view layoutIfNeeded];
            } completion:^(BOOL finished) {
                self.fourthView.backgroundColor = self.fourthColor;
                [self.view layoutIfNeeded];
                [UIView animateWithDuration:0.4299 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
                    self.fourthViewCenterConstraint.constant -= 5;
                    [self.view layoutIfNeeded];
                } completion:^(BOOL finished) {
                    self.fourthView.backgroundColor = self.firstColor;
                }];
            }];
        }];
    }];
        });
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}
/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
