//
//  ProfileViewController.m
//  plus
//
//  Created by Виктор Георгиев on 8/26/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "LoginViewController.h"

#import "Utils.h"


@interface LoginViewController ()

@property (weak, nonatomic) IBOutlet NSLayoutConstraint *whiteViewHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *profileImageViewVerticalConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *facebookButtonWidthConstraint;


@property (weak, nonatomic) IBOutlet UIButton *facebookButton;

@property (weak, nonatomic) IBOutlet UIImageView *profileImageView;

@end

@implementation LoginViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.whiteViewHeightConstraint.constant = [UIScreen mainScreen].bounds.size.height * 0.25;
    
    self.profileImageView.layer.borderColor = [UIColor colorWithRed:70 / 255.0 green:173 / 255.0 blue:198 / 255.0 alpha:1].CGColor;
    self.profileImageView.layer.borderWidth = 5;
    
    self.profileImageViewVerticalConstraint.constant = self.whiteViewHeightConstraint.constant - self.profileImageView.frame.size.height / 2;
    
    [self.facebookButton setTitle:[Utils translate:@"Login"] forState:UIControlStateNormal];
    CGFloat facebookButtonWidth = [self.facebookButton.titleLabel.text boundingRectWithSize:CGSizeMake(CGFLOAT_MAX, 40) options:NSStringDrawingUsesLineFragmentOrigin attributes: @{NSFontAttributeName : self.facebookButton.titleLabel.font} context:nil].size.width + 50 + self.facebookButton.imageView.image.size.width;
    self.facebookButtonWidthConstraint.constant = facebookButtonWidth;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (IBAction)onLoginPressed:(id)sender {
    FBSDKLoginManager *login = [[FBSDKLoginManager alloc] init];
    [login logInWithReadPermissions: @[@"user_birthday", @"user_location", @"email"]
     fromViewController:self
     handler:^(FBSDKLoginManagerLoginResult *result, NSError *error) {
         if (error) {
             NSLog(@"Process error");
         } else if (result.isCancelled) {
             NSLog(@"Cancelled");
         } else {
             self.onDismiss();
             [self.navigationController popViewControllerAnimated:YES];
         }
     }];
}

- (IBAction)onBackPressed:(id)sender {
    [self.navigationController popToRootViewControllerAnimated:YES];
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
