//
//  ViewController.h
//  plus
//
//  Created by Виктор Георгиев on 7/8/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Utils.h"
#import "BrandName.h"

#import "BrandsViewController.h"
#import "CategoriesViewController.h"
#import "MapViewController.h"

#import "SearchTextField.h"

@interface MainMenuViewController : UIViewController<UIGestureRecognizerDelegate, UIScrollViewDelegate, UINavigationControllerDelegate>

@property (strong, nonatomic) UINavigationController *contentNavigationController;

@property (strong, nonatomic) BrandsViewController *brandsViewController;

@property (strong, nonatomic) MapViewController *mapViewController;

@property (strong, nonatomic) CategoriesViewController *categoriesViewController;

@property (weak, nonatomic) IBOutlet UITableView *mainDrawerTableView;

@property (weak, nonatomic) IBOutlet SearchTextField *autocompleteTextField;
@property (weak, nonatomic) IBOutlet UITextField *searchTextField;

@property (strong, nonatomic) NSArray<BrandName *> *brandNamesArray;

@property (weak, nonatomic) IBOutlet UIView *animatedSplashScreen;

-(void)changeHeader:(NSString *)header withType:(NSString *)type;
-(void)closeFilterDrawer;
-(void)downloadContent;

-(BOOL)textFieldShouldReturn:(UITextField *)textField;

@property (weak, nonatomic) IBOutlet UIView *notificationsDotView;

@property (assign, nonatomic) long newNotificationsCount;

@property (weak, nonatomic) IBOutlet NSLayoutConstraint *notificationsDotViewLeadingConstraint;

-(void)startNotificationAnimation;

@end

