//
//  NotificationTableViewCell.m
//  plus
//
//  Created by Виктор Георгиев on 9/12/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "NotificationTableViewCell.h"

#import "NotificationsViewController.h"

@implementation NotificationTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];
}

-(void)changeRowHeight:(CGFloat)height {
    [self layoutIfNeeded];
    [UIView animateWithDuration:0.05 animations:^{
        CGFloat cellHeight;
        CGRect frame = self.frame;
        cellHeight = height + frame.size.height;
        frame.size.height = cellHeight;
        self.frame = frame;
        
        if(height > 0) {
            self.notificationHeaderImageView.image = [UIImage imageNamed:@"notifications_fold"];
        } else {
            self.notificationHeaderImageView.image = [UIImage imageNamed:@"notifications_collapse"];
        }
        [self layoutIfNeeded];
    }];
    
    [self layoutIfNeeded];
    [UIView animateWithDuration:0.05 delay:0.0 options:UIViewAnimationOptionCurveLinear animations:^{
        if(height > 0) {
            self.notificationDescriptionLabelBottomConstraint.constant = 50;
        } else {
            self.notificationDescriptionLabelBottomConstraint.constant = 10;
        }
        [self layoutIfNeeded];
    } completion:nil];
}

- (IBAction)onNotificationButtonPressed:(id)sender {
    if(self.isBrand) {
        self.notificationsViewController.brandId = ((UIButton *)sender).tag;
        [self.notificationsViewController performSegueWithIdentifier:@"BrandSegue" sender:self.notificationsViewController];
    } else {
        self.notificationsViewController.placeId = ((UIButton *)sender).tag;
        [self.notificationsViewController performSegueWithIdentifier:@"PlaceSegue" sender:self.notificationsViewController];
    }
}


@end
