//
//  NotificationsHolderViewController.m
//  plus
//
//  Created by Виктор Георгиев on 9/13/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "AppDelegate.h"

#import "NotificationsHolderViewController.h"
#import "NotificationsViewController.h"
#import "MainMenuViewController.h"

#import "Notification.h"
#import "Utils.h"

@interface NotificationsHolderViewController ()

@property (assign, nonatomic) long currentNotificationsCount;

@end

@implementation NotificationsHolderViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    MainMenuViewController *mainMenuViewController = (MainMenuViewController *)self.navigationController.viewControllers.firstObject;
    
    self.headerLabel.text = [Utils translate:@"Notifications"];
    if(mainMenuViewController.newNotificationsCount > 0) {
        self.currentNotificationsCount = mainMenuViewController.newNotificationsCount;
        self.headerImageView.image = [UIImage imageNamed:@"menu_notifications_unread"];
        self.headerNotificationsLabel.text = [NSString stringWithFormat:@"%lu", mainMenuViewController.newNotificationsCount];
        self.headerNotificationCountView.layer.borderColor = [UIColor colorWithRed:235.0 / 255 green:194.0 / 255 blue:55 / 255.0 alpha:1].CGColor;
        self.headerNotificationCountView.layer.borderWidth = 2.0f;
        self.headerNotificationCountView.hidden = NO;
    } else {
        self.headerLabel.textColor = [UIColor whiteColor];
        self.headerImageView.image = [UIImage imageNamed:@"menu_notifications"];
        self.headerLabelCenterConstraint.constant = 15;
    }
    
    mainMenuViewController.newNotificationsCount = 0;
    mainMenuViewController.notificationsDotView.hidden = YES;
    [mainMenuViewController.mainDrawerTableView reloadData];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (IBAction)onBackPressed:(id)sender {
    if(self.notificationsNavigationController.viewControllers.count == 1) {
        [self.navigationController popViewControllerAnimated:YES];
        for(Notification *notification in self.notificationsViewController.notificationsArray) {
            notification.notificationIsRead = [NSNumber numberWithInt:1];
        }
        [((AppDelegate *)[UIApplication sharedApplication].delegate) saveContext];
    } else {
        [self.notificationsNavigationController popViewControllerAnimated:YES];
        if(self.notificationsNavigationController.viewControllers.count == 1) {
            self.headerLabel.text = [Utils translate:@"Notifications"];
            self.headerImageView.hidden = NO;
            if(self.currentNotificationsCount > 0) {
                self.headerLabel.textColor = [UIColor colorWithRed:235.0 / 255 green:194.0 / 255 blue:55.0 / 255 alpha:1];
                self.headerImageView.image = [UIImage imageNamed:@"menu_notifications_unread"];
                self.headerNotificationsLabel.text = [NSString stringWithFormat:@"%lu", self.currentNotificationsCount];
                self.headerNotificationCountView.layer.borderColor = [UIColor colorWithRed:235.0 / 255 green:194.0 / 255 blue:55 / 255.0 alpha:1].CGColor;
                self.headerNotificationCountView.layer.borderWidth = 2.0f;
                self.headerNotificationCountView.hidden = NO;
            } else {
                self.headerLabel.textColor = [UIColor whiteColor];
                self.headerImageView.image = [UIImage imageNamed:@"menu_notifications"];
                self.headerLabelCenterConstraint.constant = 15;
            }
        }
    }
}

#pragma mark - Navigation

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    if([[segue destinationViewController] isKindOfClass:[UINavigationController class]]) {
        self.notificationsNavigationController = (UINavigationController *)[segue destinationViewController];
        self.notificationsViewController = (NotificationsViewController *)self.notificationsNavigationController.viewControllers.firstObject;
        ((NotificationsViewController *)self.notificationsNavigationController.viewControllers.firstObject).notificationsHolderViewController = self;
    }
}

@end
