//
//  PinView.h
//  plus
//
//  Created by Виктор Георгиев on 8/3/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <MapKit/MapKit.h>
#import "Filter.h"
#import "ItemCategory.h"

@interface PinView : UIView<CAAnimationDelegate>

@property (strong, nonatomic) UINavigationController *navigationController;

@property (strong, nonatomic) NSDictionary *pinDictionary;

@property (strong, nonatomic) NSArray<ItemCategory *> *categoriesArray;

@property (weak, nonatomic) MKMapView *mapView;
@property (weak, nonatomic) id<MKAnnotation> annotation;
@property (assign, nonatomic) CLLocationDistance pinDistance;

@property (strong, nonatomic) NSNumber *locationId;
@property (strong, nonatomic) NSNumber *categoryId;
@property (strong, nonatomic) NSNumber *followed;

@property (weak, nonatomic) IBOutlet UIImageView *pinImageView;
@property (weak, nonatomic) IBOutlet UIImageView *pinCategoryImageView;

@property (weak, nonatomic) IBOutlet NSLayoutConstraint *pinImageHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *pinWebsiteButtonHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *pinWebsiteButtonVerticalConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *pinCategoryImageViewHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *pinCategoryImageViewVerticalConstraint;

@property (weak, nonatomic) IBOutlet UIButton *pinFollowButton;
@property (weak, nonatomic) IBOutlet UIButton *pinWebsiteButton;

@property (strong, nonatomic) Filter *filter;

@property (strong, nonatomic) NSMutableArray<UILabel *> *labelsArray;
@property (weak, nonatomic) IBOutlet UILabel *pinImageViewLabel;
@property (weak, nonatomic) IBOutlet UILabel *pinCategoryLabel;
@property (weak, nonatomic) IBOutlet UILabel *pinPlaceLabel;
@property (weak, nonatomic) IBOutlet UILabel *pinPromotionLabel;
@property (weak, nonatomic) IBOutlet UILabel *pinAddressLabel;
@property (weak, nonatomic) IBOutlet UILabel *pinDistanceLabel;

-(void)setLabels;
-(void)loadAttributes;

- (IBAction)onClosePressed:(id)sender;

@property (strong, nonatomic) void (^onOpenBrand)(BOOL performSegue);

@end
