//
//  PromotionTableViewCell.m
//  plus
//
//  Created by Виктор Георгиев on 8/30/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "SingleBrandViewController.h"

#import "PromotionTableViewCell.h"

#import "PromotionButton.h"
#import "Utils.h"

@implementation PromotionTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    [self.promotionControlButton setTitle:[Utils translate:@"More information"] forState:UIControlStateNormal];
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];
}
- (IBAction)cellHeightControl:(id)sender {
    if(self.singleBrandViewController != nil) {
        int height = [self.singleBrandViewController changeRowHeight:self.index withCurrentHeight:self.frame.size.height];
        [self layoutIfNeeded];
        [UIView animateWithDuration:0.25 animations:^{
            CGRect rect = self.frame;
            int cellHeight = height - rect.size.height;
            if(rect.size.height < height) {
                self.promotionDescriptionLabel.alpha = 1;
                self.promotionImageView.alpha = 1;
                CATransition *fade = [CATransition animation];
                [self.promotionControlButton.layer addAnimation:fade forKey:@"fade"];
                
                [self.promotionControlButton setTitle:[Utils translate:@"Hide"] forState:UIControlStateNormal];
                [self.promotionControlButton setImage:[UIImage imageNamed:@"promotion_fold"] forState:UIControlStateNormal];
            } else {
                self.promotionDescriptionLabel.alpha = 0;
                self.promotionImageView.alpha = 0;
                CATransition *fade = [CATransition animation];
                [self.promotionControlButton.layer addAnimation:fade forKey:@"fade"];
                
                [self.promotionControlButton setTitle:[Utils translate:@"More information"] forState:UIControlStateNormal];
                [self.promotionControlButton setImage:[UIImage imageNamed:@"promotion_collapse"] forState:UIControlStateNormal];
            }
            rect.size.height = height;
            self.frame = rect;
            for(NSIndexPath *indexPath in self.singleBrandViewController.promotionsTableView.indexPathsForVisibleRows) {
                if(indexPath.row > self.index) {
                    UITableViewCell *cell = [self.singleBrandViewController.promotionsTableView cellForRowAtIndexPath:indexPath];
                    CGRect rect = cell.frame;
                    rect.origin.y += cellHeight;
                    cell.frame = rect;
                }
            }
            
            [self layoutIfNeeded];
        } completion:^(BOOL finished) {
            [self.singleBrandViewController.promotionsTableView reloadData];
        }];
        int tableViewHeight = 0;
        for(NSIndexPath *indexPath in self.singleBrandViewController.promotionsTableView.indexPathsForVisibleRows) {
            if(indexPath.row != self.index) {
                UITableViewCell *cell = [self.singleBrandViewController.promotionsTableView cellForRowAtIndexPath:indexPath];
                tableViewHeight += cell.frame.size.height;
            } else {
                tableViewHeight += height;
            }
        }
        [self layoutIfNeeded];
        [self.singleBrandViewController.view layoutIfNeeded];
        [UIView animateWithDuration:0.10 delay:0.08 options:UIViewAnimationOptionCurveLinear animations:^{
            self.singleBrandViewController.promotionsTableViewHeightConstraint.constant = tableViewHeight;
            [self layoutIfNeeded];
            [self.singleBrandViewController.view layoutIfNeeded];
        } completion:nil];
    } else if(self.placeViewController != nil) {
        int height = [self.placeViewController changeRowHeight:self.index withCurrentHeight:self.frame.size.height];
        [self layoutIfNeeded];
        [UIView animateWithDuration:0.25 animations:^{
            CGRect rect = self.frame;
            int cellHeight = height - rect.size.height;
            if(rect.size.height < height) {
                self.promotionDescriptionLabel.alpha = 1;
                self.promotionImageView.alpha = 1;
                CATransition *fade = [CATransition animation];
                [self.promotionControlButton.layer addAnimation:fade forKey:@"fade"];
                
                [self.promotionControlButton setTitle:[Utils translate:@"Hide"] forState:UIControlStateNormal];
                [self.promotionControlButton setImage:[UIImage imageNamed:@"promotion_fold"] forState:UIControlStateNormal];
            } else {
                self.promotionDescriptionLabel.alpha = 0;
                self.promotionImageView.alpha = 0;
                CATransition *fade = [CATransition animation];
                [self.promotionControlButton.layer addAnimation:fade forKey:@"fade"];
                
                [self.promotionControlButton setTitle:[Utils translate:@"More information"] forState:UIControlStateNormal];
                [self.promotionControlButton setImage:[UIImage imageNamed:@"promotion_collapse"] forState:UIControlStateNormal];
            }
            rect.size.height = height;
            self.frame = rect;
            for(NSIndexPath *indexPath in self.placeViewController.promotionsTableView.indexPathsForVisibleRows) {
                if(indexPath.row > self.index) {
                    UITableViewCell *cell = [self.placeViewController.promotionsTableView cellForRowAtIndexPath:indexPath];
                    CGRect rect = cell.frame;
                    rect.origin.y += cellHeight;
                    cell.frame = rect;
                }
            }
            
            [self layoutIfNeeded];
        } completion:^(BOOL finished) {
            [self.placeViewController.promotionsTableView reloadData];
        }];
        int tableViewHeight = 0;
        for(NSIndexPath *indexPath in self.placeViewController.promotionsTableView.indexPathsForVisibleRows) {
            if(indexPath.row != self.index) {
                UITableViewCell *cell = [self.placeViewController.promotionsTableView cellForRowAtIndexPath:indexPath];
                tableViewHeight += cell.frame.size.height;
            } else {
                tableViewHeight += height;
            }
        }
        [self layoutIfNeeded];
        [self.placeViewController.view layoutIfNeeded];
        [UIView animateWithDuration:0.10 delay:0.08 options:UIViewAnimationOptionCurveLinear animations:^{
            self.placeViewController.promotionsTableViewHeightConstraint.constant = tableViewHeight;
            [self layoutIfNeeded];
            [self.placeViewController.view layoutIfNeeded];
        } completion:nil];
    }

}

@end
