//
//  ShoppingCenterPlaceCollectionViewCell.m
//  plus
//
//  Created by Виктор Георгиев on 9/9/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#define DURATION 0.5f

#import "ShoppingCenterPlaceCollectionViewCell.h"

#import "ShoppingCenterViewController.h"

#import "URLRequests.h"
#import <FBSDKCoreKit/FBSDKCoreKit.h>

@implementation ShoppingCenterPlaceCollectionViewCell

- (IBAction)onFollowPressed:(id)sender {
    [URLRequests followPlace:self.followed withLocationId:self.locationId.intValue receive:^(BOOL success) {
        if(success) {
            if(self.followed == 1) {
                self.followed = 0;
                [self unfollowAnimation:self.placeFollowButton];
                NSMutableArray<NSDictionary *> *tempArray = [[NSMutableArray alloc] initWithCapacity:self.shoppingCenterViewController.shoppingCenterPlacesArray.count];
                for(NSDictionary *shoppingCenter in self.shoppingCenterViewController.shoppingCenterPlacesArray) {
                    NSMutableDictionary *tempDict = [shoppingCenter mutableCopy];
                    if([[shoppingCenter objectForKey:@"id"] intValue] == self.locationId.intValue) {
                        [tempDict setObject:[NSNumber numberWithInt:self.followed] forKey:@"followed"];
                        break;
                    }
                    [tempArray addObject:tempDict];
                }
                self.shoppingCenterViewController.shoppingCenterPlacesArray = tempArray;
            } else {
                self.followed = 1;
                [self followAnimation:self.placeFollowButton];
                NSMutableArray<NSDictionary *> *tempArray = [[NSMutableArray alloc] initWithCapacity:self.shoppingCenterViewController.shoppingCenterPlacesArray.count];
                for(NSDictionary *shoppingCenter in self.shoppingCenterViewController.shoppingCenterPlacesArray) {
                    NSMutableDictionary *tempDict = [shoppingCenter mutableCopy];
                    if([[shoppingCenter objectForKey:@"id"] intValue] == self.locationId.intValue) {
                        [tempDict setObject:[NSNumber numberWithInt:self.followed] forKey:@"followed"];
                        break;
                    }
                    [tempArray addObject:tempDict];
                }
                self.shoppingCenterViewController.shoppingCenterPlacesArray = tempArray;
            }
        }
    }];
}

- (void)animationDidStop:(CAAnimation *)theAnimation finished:(BOOL)flag {
    if(self.followed) {
        [self.placeFollowButton setImage:[UIImage imageNamed:@"remove_from_favs"] forState:UIControlStateNormal];
    } else {
        [self.placeFollowButton setImage:[UIImage imageNamed:@"add_to_favs"] forState:UIControlStateNormal];
    }
}

-(void)followAnimation:(UIButton *)button {
    
    CABasicAnimation *rotate = [CABasicAnimation animationWithKeyPath:@"transform.rotation"];
    rotate.fromValue = [NSNumber numberWithFloat:0];
    rotate.toValue = [NSNumber numberWithFloat:-6.5];
    rotate.duration = DURATION;
    rotate.repeatCount = 1;
    CABasicAnimation *zoomOut = [CABasicAnimation animationWithKeyPath:@"transform.scale"];
    zoomOut.fromValue = [NSNumber numberWithFloat:1];
    zoomOut.toValue = [NSNumber numberWithFloat:0.2];
    zoomOut.duration = DURATION / 2;
    zoomOut.repeatCount = 1;
    CABasicAnimation *zoomIn = [CABasicAnimation animationWithKeyPath:@"transform.scale"];
    zoomIn.fromValue = [NSNumber numberWithFloat:0.2];
    zoomIn.toValue = [NSNumber numberWithFloat:1];
    zoomIn.duration = DURATION / 4;
    zoomIn.beginTime = CACurrentMediaTime() + DURATION * 3 / 4;
    zoomIn.repeatCount = 1;
    CABasicAnimation *fadeOut = [CABasicAnimation animationWithKeyPath:@"opacity"];
    fadeOut.delegate = self;
    fadeOut.fromValue = [NSNumber numberWithFloat:1.0];
    fadeOut.toValue = [NSNumber numberWithFloat:0.0];
    fadeOut.duration = DURATION / 4;
    fadeOut.repeatCount = 1;
    CABasicAnimation *continueFade = [CABasicAnimation animationWithKeyPath:@"opacity"];
    continueFade.fromValue = [NSNumber numberWithFloat:0];
    continueFade.toValue = [NSNumber numberWithFloat:0.0];
    continueFade.beginTime = CACurrentMediaTime() + DURATION / 4;
    continueFade.duration = DURATION / 2;
    continueFade.repeatCount = 1;
    
    [button.layer addAnimation:rotate forKey:nil];
    [button.layer addAnimation:zoomOut forKey:nil];
    [button.layer addAnimation:zoomIn forKey:nil];
    [button.layer addAnimation:fadeOut forKey:nil];
    [button.layer addAnimation:continueFade forKey:nil];
}

-(void)unfollowAnimation:(UIButton *)button {
    CABasicAnimation *zoomOut = [CABasicAnimation animationWithKeyPath:@"transform.scale"];
    zoomOut.delegate = self;
    zoomOut.fromValue = [NSNumber numberWithFloat:1];
    zoomOut.toValue = [NSNumber numberWithFloat:0.05];
    zoomOut.duration = DURATION / 2;
    zoomOut.repeatCount = 1;
    CABasicAnimation *zoomIn = [CABasicAnimation animationWithKeyPath:@"transform.scale"];
    zoomIn.fromValue = [NSNumber numberWithFloat:0.05];
    zoomIn.toValue = [NSNumber numberWithFloat:1];
    zoomIn.duration = DURATION / 2 + DURATION / 10;
    zoomIn.beginTime = CACurrentMediaTime() + DURATION / 2 - DURATION / 10;
    zoomIn.repeatCount = 1;
    
    [button.layer addAnimation:zoomOut forKey:nil];
    [button.layer addAnimation:zoomIn forKey:nil];
}


@end
