//
//  TermsAndConditionsViewController.m
//  plus
//
//  Created by Виктор Георгиев on 9/15/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "TermsAndConditionsViewController.h"

#import "Utils.h"

@interface TermsAndConditionsViewController ()

@property (weak, nonatomic) IBOutlet UILabel *headerLabel;

@property (weak, nonatomic) IBOutlet UILabel *termsAndConditionsLabel;

@end

@implementation TermsAndConditionsViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.headerLabel.text = [Utils translate:@"Terms and conditions"];
    
    NSBundle *bundle = [NSBundle mainBundle];
    NSString *path;
    if([[Utils currentLanguage] isEqualToString:@"bg"]) {
        path = [bundle pathForResource:@"Terms_bg" ofType:@"html"];
    } else {
        path = [bundle pathForResource:@"Terms_en" ofType:@"html"];
    }
    NSData *data = [NSData dataWithContentsOfFile:path];
    NSMutableAttributedString * attributedString = [[NSMutableAttributedString alloc] initWithData:data options:@{NSDocumentTypeDocumentAttribute: NSHTMLTextDocumentType} documentAttributes:nil error:nil];
    [attributedString addAttribute:NSFontAttributeName value:[UIFont fontWithName:@"PTSans-Regular" size:16] range:NSMakeRange(0, attributedString.length)];

    self.termsAndConditionsLabel.attributedText = attributedString;

}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (IBAction)onBackPressed:(id)sender {
    [self.navigationController popViewControllerAnimated:YES];
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
