//
//  URLRequests.h
//  plus
//
//  Created by Виктор Георгиев on 7/12/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <CoreLocation/CoreLocation.h>

#import "Brand.h"
#import "ShoppingCenter.h"

@class NewPlace;
@class BrandName;

@interface URLRequests : NSObject

+(void) setUser:(NSString *)language facebookId:(NSString *)facebookId email:(NSString *)email firstname:(NSString *)firstname lastname:(NSString *)lastname receive:(void (^)(NSData *data))receive;

+(void) getCategories:(NSString *)language receive:(void (^)(NSArray *categories))receive;

+(UIImage *) loadImage:(NSString *)urlString withFolder:(NSString *)folder receive:(void (^)(UIImage *image))receive;

+(UIImage *) getImage:(NSString *)urlString;

+(void) getNew:(void (^)(NSArray<NewPlace *> *newPlacesArray))receive;

+(void) getPromotions:(CLLocationCoordinate2D)location page:(int)page receive:(void (^)(NSDictionary *mainDict, NSArray *items))receive;

+(void) getFollowed:(void (^)(NSArray<NewPlace*> *items))receive;

+(void) getShoppingCenters:(CLLocationCoordinate2D)location page:(int)page receive:(void (^)(NSDictionary *mainDict, NSArray *items))receive;

+(void) getShoppingCenter:(int)shoppingCenterId receive:(void (^)(NSData *data))receive;

+(void) getShoppingCenterPlaces:(int)shoppingCenterId receive:(void (^)(NSData *data))receive;

+(void) getItem:(int)itemid receive:(void (^)(NSData *data))receive;

+(void) getBrand:(int)brandId receive:(void (^)(NSData *data))receive;

+(void) getBrands:(CLLocationCoordinate2D)location language:(NSString *)language page:(int)page filter:(NSString *)filter keyword:(NSString *)keyword displayAnimation:(BOOL)animation receive:(void (^)(NSArray<Brand *> *items, long brandsCount))receive;

+(void)getBrandsList:(void (^)(BOOL success, NSArray<BrandName *> *brandNamesArray))receive;

+(void) getPins:(CLLocationCoordinate2D)location withFilters:(NSString *)filters receive:(void (^)(NSData *data))receive;

+(void) getPin:(int)locationId withLanguage:(NSString *)language receive:(void (^)(NSDictionary *dictionary))receive;

+(void) getNotifications:(void (^)(long newNotifications))receive;

+(void) sendFeedBack:(NSString *)phone email:(NSString *)email message:(NSString *)message;

+(void) followPlace:(int)hasToFollow withLocationId:(int)locationId receive:(void (^)(BOOL success))receive;

+(void) followBrand:(int)hasToFollow withLocationId:(int)locationId receive:(void (^)(BOOL success))receive;

@end
