//
//  URLRequests.m
//  plus
//
//  Created by Виктор Георгиев on 7/12/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "AppDelegate.h"

#import "URLRequests.h"
#import "ItemCategory.h"
#import "ShoppingCenter.h"
#import "Promotion.h"
#import "BrandName.h"
#import "Notification.h"
#import "NewPlace.h"

#import "LoadAnimationViewController.h"
#import "MainMenuViewController.h"

@implementation URLRequests
// production URL
static NSString *const BASE_URL = @"https://plus.infozone.co/api/";
// development URL
//static NSString *const BASE_URL = @"http://192.168.2.27/api/";

static NSString *const API_KEY = @"3a57c518a31ecdfef9488eee3bb07a73";

+ (void) setUser:(NSString *)language facebookId:(NSString *)facebookId email:(NSString *)email firstname:(NSString *)firstname lastname:(NSString *)lastname receive:(void (^)(NSData *data))receive {
    NSString *deviceid = [UIDevice currentDevice].identifierForVendor.UUIDString;
    NSData *token = [[NSUserDefaults standardUserDefaults] objectForKey:@"deviceToken"];
    NSMutableString *deviceToken = [[NSMutableString alloc] init];
    for(int i=0; i < token.length; i++) {
        [deviceToken appendFormat:@"%02x", *((unsigned char *)[token bytes] + i)];
    }
    //[deviceToken appendString:@"iOSSimulator"];
    NSString *urlString;
    if(facebookId != nil) {
        urlString = [NSString stringWithFormat:@"%@user?api_key=%@&type=iOS&device_id=%@&device_token=%@&selected_language=%@&fb_id=%@&email=%@&first_name=%@&last_name=%@", BASE_URL, API_KEY,  deviceid, deviceToken, language, facebookId, [email stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]], [firstname stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]], [lastname stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]]];
    } else {
        urlString = [NSString stringWithFormat:@"%@user?api_key=%@&type=iOS&device_id=%@&device_token=%@&selected_language=%@", BASE_URL, API_KEY, deviceid, deviceToken, language];
    }
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            receive(data);
        }
    }];
    [urlConnection resume];
}

+ (void) getCategories:(NSString *)language receive:(void (^)(NSArray *categories))receive {
    NSString *urlString = [NSString stringWithFormat:@"%@categories?api_key=%@&lang=%@", BASE_URL, API_KEY, language];
    urlString = [urlString stringByAppendingString:[NSString stringWithFormat:@"&size=%@", [self imageSize]]];
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
            if(dict != nil && [dict isKindOfClass:[NSDictionary class]]) {
                NSMutableArray *categoriesArray = [NSMutableArray arrayWithCapacity:[dict count]];
                for(NSString *key in dict.allKeys) {
                    NSDictionary *item = (NSDictionary *)[dict objectForKey:key];
                    if([(NSString *)[item objectForKey:@"parent_id"] intValue] == 0) {
                        ItemCategory *itemCategory = [[ItemCategory alloc] init];
                        itemCategory.itemId = [item objectForKey:@"id"];
                        itemCategory.itemName = [item objectForKey:@"name"];
                        itemCategory.itemParentId = [item objectForKey:@"parent_id"];
                        itemCategory.itemMapIcon = [[item objectForKey:@"map_icon"] objectForKey:@"image"];
                        itemCategory.itemCategoryIcon = [[item objectForKey:@"category_icon"] objectForKey:@"image"];
                        itemCategory.itemCategoryPinColor = [item objectForKey:@"color"];
                        itemCategory.itemCategoryPinIcon = [[item objectForKey:@"category_colored"] objectForKey:@"image"];
                        [categoriesArray addObject:itemCategory];
                    }
                }
                for(ItemCategory *itemCategory in categoriesArray) {
                    NSMutableArray<ItemCategory *> *subCategoriesArray = [[NSMutableArray alloc] init];
                    for(NSString *key in dict.allKeys) {
                         NSDictionary *item = (NSDictionary *)[dict objectForKey:key];
                        if([[item objectForKey:@"parent_id"] intValue] == [itemCategory.itemId intValue]) {
                            ItemCategory *itemCategory = [[ItemCategory alloc] init];
                            itemCategory.itemId = [item objectForKey:@"id"];
                            itemCategory.itemName = [item objectForKey:@"name"];
                            itemCategory.itemParentId = [item objectForKey:@"parent_id"];
                            itemCategory.itemMapIcon = [[item objectForKey:@"map_icon"] objectForKey:@"image"];
                            itemCategory.itemCategoryIcon = [[item objectForKey:@"category_icon"] objectForKey:@"image"];
                            itemCategory.itemCategoryPinColor = [item objectForKey:@"color"];
                            itemCategory.itemCategoryPinIcon = [[item objectForKey:@"category_colored"] objectForKey:@"image"];
                            [subCategoriesArray addObject:itemCategory];
                        }
                    }
                    NSMutableArray *temp = [categoriesArray mutableCopy];
                    itemCategory.itemSubcategories = subCategoriesArray;
                    [temp replaceObjectAtIndex:[temp indexOfObject:itemCategory] withObject:itemCategory];
                    NSArray *sorted = [temp sortedArrayUsingComparator:^NSComparisonResult(id a, id b) {
                        NSNumber *first = [(ItemCategory *)a itemId];
                        NSNumber *second = [(ItemCategory *)b itemId];
                        return [first compare:second];
                    }];
                    categoriesArray = [sorted copy];

                }
                receive((NSArray *)categoriesArray);
            }
        }
    }];
    [urlConnection resume];
}

+(UIImage *) loadImage:(NSString *)urlString withFolder:(NSString *)folder receive:(void (^)(UIImage *image))receive {
    urlString = [urlString stringByReplacingOccurrencesOfString:@" " withString:@"%20"];
    NSString *fileName;
    NSRange range = [urlString rangeOfString:@"//"];
    if(range.location != NSNotFound) {
        range = [urlString rangeOfString:@"/" options:0 range:NSMakeRange(range.location + 2, urlString.length - range.location - 2)];
        if(range.location != NSNotFound) {
            fileName = [urlString substringFromIndex:range.location + 1];
            fileName = [fileName stringByReplacingOccurrencesOfString:@"/" withString:@"_"];
        }
    }
    NSError *error;
    NSFileManager *fileManager = [NSFileManager defaultManager];
    NSURL *folderURL = [fileManager URLForDirectory:NSDocumentDirectory inDomain:NSUserDomainMask appropriateForURL:nil create:NO error:&error];
    folderURL = [folderURL URLByAppendingPathComponent:@"images"];
    if(folder != nil) {
        folderURL = [folderURL URLByAppendingPathComponent:folder];
    }
    if(![fileManager fileExistsAtPath:folderURL.path]) {
        [fileManager createDirectoryAtPath:folderURL.path withIntermediateDirectories:YES attributes:nil error:&error];
    }

    if(fileName != nil) {
        folderURL = [folderURL URLByAppendingPathComponent:fileName];
        if([fileManager fileExistsAtPath:folderURL.path]) {
            return [UIImage imageWithContentsOfFile:folderURL.path];
        } else {
            NSURL *url = [NSURL URLWithString:urlString];
            NSURLRequest *request = [NSURLRequest requestWithURL:url];
            NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
            NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
            NSURLSessionDownloadTask *downloadTask = [urlSession downloadTaskWithRequest:request completionHandler:^(NSURL * _Nullable location, NSURLResponse * _Nullable response, NSError * _Nullable error) {
                if(location != nil) {
                    [fileManager moveItemAtURL:location toURL:folderURL error:&error];
                    UIImage *downloadedImage = [UIImage imageWithContentsOfFile:folderURL.path];
                    if(receive != nil) {
                        receive(downloadedImage);
                    }
                    [self checkImagesFolderSize];
                }
            }];
            [downloadTask resume];
            return nil;
        }
    }
    return nil;
}

+(UIImage *) getImage:(NSString *)urlString {
    urlString = [urlString stringByReplacingOccurrencesOfString:@" " withString:@"%20"];
    NSString *fileName;
    NSRange range = [urlString rangeOfString:@"//"];
    if(range.location != NSNotFound) {
        range = [urlString rangeOfString:@"/" options:0 range:NSMakeRange(range.location + 2, urlString.length - range.location - 2)];
        if(range.location != NSNotFound) {
            fileName = [urlString substringFromIndex:range.location + 1];
            fileName = [fileName stringByReplacingOccurrencesOfString:@"/" withString:@"_"];
        }
    }
    NSError *error;
    NSFileManager *fileManager = [NSFileManager defaultManager];
    NSURL *folderURL = [fileManager URLForDirectory:NSDocumentDirectory inDomain:NSUserDomainMask appropriateForURL:nil create:NO error:&error];
    folderURL = [folderURL URLByAppendingPathComponent:@"images"];
    if(![fileManager fileExistsAtPath:folderURL.path]) {
        [fileManager createDirectoryAtPath:folderURL.path withIntermediateDirectories:YES attributes:nil error:&error];
    }
    
    if(fileName != nil) {
        folderURL = [folderURL URLByAppendingPathComponent:fileName];
        if([fileManager fileExistsAtPath:folderURL.path]) {
            return [UIImage imageWithContentsOfFile:folderURL.path];
        } else {
            return nil;
        }
    } else {
        return nil;
    }
}

+ (void) getBrand:(int)brandId receive:(void (^)(NSData *data))receive {
    [Utils displayAnimation];
    NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
    int userId = [NSNumber numberWithInteger:[userDefaults integerForKey:@"userId"]].intValue;
    NSString *urlString = [NSString stringWithFormat:@"%@brand?api_key=%@&brand_id=%d&user_id=%d&size=%@&lang=%@", BASE_URL, API_KEY, brandId, userId, [self imageSize], [Utils currentLanguage]];
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            receive(data);
            [Utils dismissAnimation];
        }
    }];
    [urlConnection resume];
}

+ (void) getBrands:(CLLocationCoordinate2D)location language:(NSString *)language page:(int)page filter:(NSString *)filter keyword:(NSString *)keyword displayAnimation:(BOOL)animation receive:(void (^)(NSArray<Brand *> *items, long brandsCount))receive {
    if(animation) {
        [Utils displayAnimation];
    }
    
    NSString *urlString = [NSString stringWithFormat:@"%@brands?api_key=%@&lang=%@", BASE_URL, API_KEY, language];
    if(CLLocationCoordinate2DIsValid(location)) {
        urlString = [urlString stringByAppendingFormat:@"&lat=%f&lng=%f", location.latitude, location.longitude];
    }
    if(filter != nil) {
        urlString = [urlString stringByAppendingFormat:@"&category_id=%@", filter];
    }
    if(page >= 0) {
        urlString = [urlString stringByAppendingFormat:@"&page=%d", page];
    }
    if(keyword != nil) {
        urlString = [urlString stringByAppendingFormat:@"&search=%@", keyword];
    }
    
    urlString = [urlString stringByAppendingFormat:@"&size=%@", [self imageSize]];
    
    int userId = [NSNumber numberWithInteger:[[NSUserDefaults standardUserDefaults] integerForKey:@"userId"]].intValue;
    urlString = [urlString stringByAppendingFormat:@"&user_id=%d", userId];
    
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        NSMutableArray<Brand *> *brands = [[NSMutableArray alloc] init];
        long brandCount = 0;
        if(data != nil) {
            NSArray *brandsArray = [NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
            for(NSDictionary *brandDictionary in brandsArray) {
                if([brandDictionary isKindOfClass:[NSDictionary class]]) {
                    Brand *brand = [[Brand alloc] init];
                    brand.brandId = [brandDictionary objectForKey:@"id"];
                    brand.brandName = [brandDictionary objectForKey:@"name"];
                    brand.brandCategoryId = [brandDictionary objectForKey:@"category_id"];
                    if(((NSNumber *)[brandDictionary objectForKey:@"brand"]).intValue == 1) {
                        brand.isBrand = YES;
                    } else {
                        brand.isBrand = NO;
                    }
                    if(((NSNumber *)[brandDictionary objectForKey:@"followed"]).intValue == 1) {
                        brand.isFollowed = YES;
                    } else {
                        brand.isFollowed  = NO;
                    }
                    brand.brandImage = [brandDictionary objectForKey:@"image"];
                    if(brand.isBrand) {
                        brand.brandCount = [brandDictionary objectForKey:@"count"];
                    } else {
                        brand.brandCount = [NSNumber numberWithInt:0];
                    }
                    brand.brandLatitude = [brandDictionary objectForKey:@"lat"];
                    brand.brandLongitude = [brandDictionary objectForKey:@"lng"];
                    if([[brandDictionary objectForKey:@"new_brand"] boolValue] == YES) {
                        brand.brandIsNewBrand = YES;
                    } else {
                        brand.brandIsNewBrand  = NO;
                    }
                    if([[brandDictionary objectForKey:@"new_location"] boolValue] == YES) {
                        brand.brandIsNewLocation = YES;
                    } else {
                        brand.brandIsNewLocation  = NO;
                    }
                    if([brandDictionary objectForKey:@"color"]) {
                        brand.brandColor = [brandDictionary objectForKey:@"color"];
                    }
                    if([brandDictionary objectForKey:@"has_promotion"]) {
                        if([[brandDictionary objectForKey:@"has_promotion"] intValue] == 0) {
                            brand.hasPromotion = NO;
                        } else {
                            brand.hasPromotion = YES;
                        }
                    }
                    
                    [brands addObject:brand];
                } else if([brandDictionary isKindOfClass:[NSNumber class]]) {
                    brandCount = ((NSNumber *)brandDictionary).longValue;
                }
                    
            }
            receive(brands, brandCount);
            
            if(animation) {
                [Utils dismissAnimation];
            }
        } else {
            receive(brands, brandCount);
        }
    }];
    [urlConnection resume];
}

+ (void)getBrandsList:(void (^)(BOOL success, NSArray<BrandName *> *brandNamesArray))receive {
    NSString *urlString = [NSString stringWithFormat:@"%@brands/basic?api_key=%@&lang=%@", BASE_URL, API_KEY, [Utils currentLanguage]];
    NSManagedObjectContext *managedObjectContext = ((AppDelegate *)[UIApplication sharedApplication].delegate).managedObjectContext;
    NSError *error;
    NSFetchRequest *fetchRequest = [NSFetchRequest fetchRequestWithEntityName:@"BrandName"];
    NSArray<BrandName *> *brandNames = [managedObjectContext executeFetchRequest:fetchRequest error:&error];
    NSString *date = nil;
    if(brandNames.count > 0) {
        NSDateComponents *components = [[NSCalendar currentCalendar] components:NSCalendarUnitDay | NSCalendarUnitMonth | NSCalendarUnitYear fromDate:[NSDate date]];
        NSInteger day = [components day];
        NSInteger month = [components month];
        NSInteger year = [components year];
        date = [NSString stringWithFormat:@"%ld-%ld-%ld", (long)year, (long)month, (long)day];
    }
    if(date != nil) {
        urlString = [urlString stringByAppendingFormat:@"&date=%@", date];
    }
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            NSArray<NSDictionary *> *brandsArray = [NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
            NSManagedObjectContext *managedObjectContext = ((AppDelegate *)[UIApplication sharedApplication].delegate).managedObjectContext;
            NSFetchRequest *request = [NSFetchRequest fetchRequestWithEntityName:@"BrandName"];
            for(NSDictionary *brandDictionary in brandsArray) {
                request.predicate = [NSPredicate predicateWithFormat:@"brandId == %d", [[brandDictionary objectForKey:@"id"] intValue]];
                NSArray<BrandName *> *brandNamesArray = [managedObjectContext executeFetchRequest:request error:&error];
                if(brandNamesArray.count == 0) {
                    BrandName *brand = [NSEntityDescription insertNewObjectForEntityForName:@"BrandName" inManagedObjectContext:managedObjectContext];
                    brand.brandId = [NSNumber numberWithInt:[[brandDictionary objectForKey:@"id"] intValue]];
                    brand.brandName = [NSString stringWithFormat:@"%@", [brandDictionary objectForKey:@"name"]];
                } else {
                    BrandName *brand = [brandNamesArray objectAtIndex:0];
                    brand.brandId = [NSNumber numberWithInt:[[brandDictionary objectForKey:@"id"] intValue]];
                    brand.brandName = [brandDictionary objectForKey:@"name"];
                }
                [((AppDelegate *)[UIApplication sharedApplication].delegate) saveContext];
            }
            request.predicate = nil;
            NSArray<BrandName *> *brandNamesArray = (NSArray<BrandName *> *)[managedObjectContext executeFetchRequest:request error:&error];
            receive(YES, brandNamesArray);
        } else {
            receive(NO, nil);
        }
    }];
    [urlConnection resume];
}

+ (void) getNew:(void (^)(NSArray<NewPlace *> *newPlacesArray))receive {
    [Utils displayAnimation];

    long userId = [[NSUserDefaults standardUserDefaults] integerForKey:@"userId"];
    NSString *urlString = [NSString stringWithFormat:@"%@brands/new?api_key=%@&lang=%@&size=%@&user_id=%lu", BASE_URL, API_KEY, [Utils currentLanguage], [self imageSize], userId];
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            NSArray *placesArray = [NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
            NSMutableArray<NewPlace *> *newPlaces = [[NSMutableArray alloc] init];
            for(NSDictionary *newPlaceDictionary in placesArray) {
                NewPlace *newPlace = [[NewPlace alloc] init];
                newPlace.placeId = [newPlaceDictionary objectForKey:@"id"];
                newPlace.placeName = [newPlaceDictionary objectForKey:@"name"];
                newPlace.placeCategoryId = [newPlaceDictionary objectForKey:@"category_id"];
                newPlace.placeBackgroundColor = [newPlaceDictionary objectForKey:@"color"];
                if(((NSNumber *)[newPlaceDictionary objectForKey:@"brand"]).intValue == 1) {
                    newPlace.placeIsBrand = YES;
                } else {
                    newPlace.placeIsBrand = NO;
                }
                if(newPlace.placeIsBrand) {
                    newPlace.placeCount = [newPlaceDictionary objectForKey:@"count"];
                } else {
                    newPlace.placeCount = [NSNumber numberWithInt:0];
                }
                newPlace.placeImage = [newPlaceDictionary objectForKey:@"image"];
                newPlace.placeLatitude = [newPlaceDictionary objectForKey:@"lat"];
                newPlace.placeLongitude = [newPlaceDictionary objectForKey:@"lng"];
                if(((NSNumber *)[newPlaceDictionary objectForKey:@"followed"]).intValue == 1) {
                    newPlace.placeIsFollowed = YES;
                } else {
                    newPlace.placeIsFollowed  = NO;
                }
                
                if([newPlaceDictionary objectForKey:@"new_brand"]) {
                    if([[newPlaceDictionary objectForKey:@"new_brand"] boolValue] == YES) {
                        newPlace.placeIsNewBrand = YES;
                    } else {
                        newPlace.placeIsNewBrand = NO;
                    }
                }
                
                if([newPlaceDictionary objectForKey:@"new_location"]) {
                    if([[newPlaceDictionary objectForKey:@"new_location"] boolValue] == YES) {
                        newPlace.placeIsNewLocation = YES;
                    } else {
                        newPlace.placeIsNewLocation = NO;
                    }
                }
                
                [newPlaces addObject:newPlace];
            }
            receive(newPlaces);
        }
        [Utils dismissAnimation];
    }];
    [urlConnection resume];
}

+ (void) getPromotions:(CLLocationCoordinate2D)location page:(int)page receive:(void (^)(NSDictionary *mainDict, NSArray *items))receive {
    [Utils displayAnimation];
    
    long userId = [[NSUserDefaults standardUserDefaults] integerForKey:@"userId"];
    NSString *urlString = [NSString stringWithFormat:@"%@locations/basic?api_key=%@&user_id=%lu&promotions=1&lang=%@", BASE_URL, API_KEY, userId, [Utils currentLanguage]];
    if(CLLocationCoordinate2DIsValid(location)) {
        urlString = [urlString stringByAppendingFormat:@"&lat=%f&lng=%f", location.latitude, location.longitude];
    }
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            NSDictionary *objectDict = [NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
            NSArray *array = [objectDict objectForKey:@"data"];
            NSMutableArray<Promotion *> *promotionsArray = [[NSMutableArray alloc] init];
            for(NSDictionary *item in array) {
                Promotion *promotion = [[Promotion alloc] init];
                promotion.promotionId = [item objectForKey:@"id"];
                promotion.promotionName = [item objectForKey:@"name"];
                promotion.promotionLatitude = [item objectForKey:@"lat"];
                promotion.promotionLongitude = [item objectForKey:@"lng"];
                if([[item objectForKey:@"is_mall"] isKindOfClass:[NSString class]] && [item objectForKey:@"is_mall"] != nil && ![[item objectForKey:@"is_mall"] isEqualToString:@"null"]) {
                    promotion.promotionIsMall = YES;
                } else {
                    promotion.promotionIsMall = NO;
                }
                promotion.promotionLastUpdated = [item objectForKey:@"updated_at"];
                promotion.promotionBackgroundColor = [item objectForKey:@"color"];
                promotion.promotionNewUpdated = [item objectForKey:@"new_at"];
                promotion.promotionDistance = [item objectForKey:@"distance"];
                promotion.promotionCategories = [item objectForKey:@"categories"];
                promotion.promotionLogos = [item objectForKey:@"logo"];
                promotion.promotionFollowed = [item objectForKey:@"followed"];
                promotion.promotionHasPromotion = [item objectForKey:@"has_promotion"];
                promotion.promotionNewLocation = [item objectForKey:@"new_location"];
                [promotionsArray addObject:promotion];
            }
            receive(objectDict, promotionsArray);
        }
        [Utils dismissAnimation];
    }];
    [urlConnection resume];
}

+ (void) getFollowed:(void (^)(NSArray<NewPlace*> *items))receive {
    [Utils displayAnimation];
    
    long userId = [[NSUserDefaults standardUserDefaults] integerForKey:@"userId"];
    NSString *urlString = [NSString stringWithFormat:@"%@locations/followed?api_key=%@&&user_id=%lu&lang=%@", BASE_URL, API_KEY, userId, [Utils currentLanguage]];
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            NSArray *placesArray = [NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
            NSMutableArray<NewPlace *> *newPlaces = [[NSMutableArray alloc] init];
            for(NSDictionary *newPlaceDictionary in placesArray) {
                NewPlace *newPlace = [[NewPlace alloc] init];
                newPlace.placeId = [newPlaceDictionary objectForKey:@"id"];
                newPlace.placeName = [newPlaceDictionary objectForKey:@"name"];
                newPlace.placeCategoryId = [newPlaceDictionary objectForKey:@"category_id"];
                newPlace.placeBackgroundColor = [newPlaceDictionary objectForKey:@"color"];
                if(((NSNumber *)[newPlaceDictionary objectForKey:@"brand"]).intValue == 1) {
                    newPlace.placeIsBrand = YES;
                } else {
                    newPlace.placeIsBrand = NO;
                }
                if(newPlace.placeIsBrand) {
                    newPlace.placeCount = [newPlaceDictionary objectForKey:@"count"];
                } else {
                    newPlace.placeCount = [NSNumber numberWithInt:0];
                }
                if([newPlaceDictionary objectForKey:@"new_brand"]) {
                    if([[newPlaceDictionary objectForKey:@"new_brand"] boolValue] == YES) {
                        newPlace.placeIsNewBrand = YES;
                    } else {
                        newPlace.placeIsNewBrand = NO;
                    }
                }
                
                if([newPlaceDictionary objectForKey:@"new_location"]) {
                    if([[newPlaceDictionary objectForKey:@"new_location"] boolValue] == YES) {
                        newPlace.placeIsNewLocation = YES;
                    } else {
                        newPlace.placeIsNewLocation = NO;
                    }
                }
                newPlace.placeImage = [newPlaceDictionary objectForKey:@"image"];
                newPlace.placeLatitude = [newPlaceDictionary objectForKey:@"lat"];
                newPlace.placeLongitude = [newPlaceDictionary objectForKey:@"lng"];
                if(((NSNumber *)[newPlaceDictionary objectForKey:@"followed"]).intValue == 1) {
                    newPlace.placeIsFollowed = YES;
                } else {
                    newPlace.placeIsFollowed  = NO;
                }
                
                [newPlaces addObject:newPlace];
            }
            receive(newPlaces);
        }
        [Utils dismissAnimation];
    }];
    [urlConnection resume];
}

+ (void) getShoppingCenters:(CLLocationCoordinate2D)location page:(int)page receive:(void (^)(NSDictionary *mainDict, NSArray *items))receive {
    [Utils displayAnimation];
    
    long userId = [[NSUserDefaults standardUserDefaults] integerForKey:@"userId"];
    NSString *urlString = [NSString stringWithFormat:@"%@locations/basic?api_key=%@&user_id=%lu&only_mall=1&size=%@&lang=%@", BASE_URL, API_KEY, userId, [self imageSize], [Utils currentLanguage]];
    if(CLLocationCoordinate2DIsValid(location)) {
        urlString = [urlString stringByAppendingFormat:@"&lat=%f&lng=%f", location.latitude, location.longitude];
    }
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            NSDictionary *objectDict = [NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
            NSArray *array = [objectDict objectForKey:@"data"];
            NSMutableArray<ShoppingCenter *> *shoppingCentersArray = [[NSMutableArray alloc] init];
            for(NSDictionary *item in array) {
                ShoppingCenter *shoppingCenter = [[ShoppingCenter alloc] init];
                shoppingCenter.shoppingCenterId = [item objectForKey:@"id"];
                shoppingCenter.shoppingCenterName = [item objectForKey:@"name"];
                shoppingCenter.shoppingCenterLatitude = [item objectForKey:@"lat"];
                shoppingCenter.shoppingCenterLongitude = [item objectForKey:@"lng"];
                if(![item isKindOfClass:[NSNull class]] && ![[item objectForKey:@"is_mall"] isKindOfClass:[NSNull class]] && [[item objectForKey:@"is_mall"] intValue] == 1) {
                    shoppingCenter.shoppingCenterIsMall = YES;
                } else {
                    shoppingCenter.shoppingCenterIsMall = NO;
                }
                shoppingCenter.shoppingCenterLastUpdated = [item objectForKey:@"updated_at"];
                shoppingCenter.shoppingCenterBackgroundColor = [item objectForKey:@"color"];
                shoppingCenter.shoppingCenterNewUpdated = [item objectForKey:@"new_at"];
                shoppingCenter.shoppingCenterDistance = [item objectForKey:@"distance"];
                shoppingCenter.shoppingCenterCategories = [item objectForKey:@"categories"];
                shoppingCenter.shoppingCenterLogos = [item objectForKey:@"logo"];
                shoppingCenter.shoppingCenterFollowed = [item objectForKey:@"followed"];
                shoppingCenter.shoppingCenterHasPromotion = [item objectForKey:@"has_promotion"];
                shoppingCenter.shoppingCenterPlacesCount = [item objectForKey:@"count"];
                shoppingCenter.shoppingCenterNewLocation = [item objectForKey:@"new_location"];
                [shoppingCentersArray addObject:shoppingCenter];
            }
            receive(objectDict, shoppingCentersArray);
        }
        [Utils dismissAnimation];
    }];
    [urlConnection resume];
}

+(void) getShoppingCenter:(int)shoppingCenterId receive:(void (^)(NSData *data))receive {
    [Utils displayAnimation];
    
    NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
    int userId = [NSNumber numberWithInteger:[userDefaults integerForKey:@"userId"]].intValue;
    NSString *urlString = [NSString stringWithFormat:@"%@locations?api_key=%@&location_ids=%d&user_id=%d&size=%@&lang=%@", BASE_URL, API_KEY, shoppingCenterId, userId, [self imageSize], [Utils currentLanguage]];
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            receive(data);
        }
        [Utils dismissAnimation];
    }];
    [urlConnection resume];
}

+(void) getShoppingCenterPlaces:(int)shoppingCenterId receive:(void (^)(NSData *data))receive {
    [Utils displayAnimation];
    
    NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
    int userId = [NSNumber numberWithInteger:[userDefaults integerForKey:@"userId"]].intValue;
    NSString *urlString = [NSString stringWithFormat:@"%@locations/basic?api_key=%@&shopping_centres=%d&user_id=%d&size=%@&lang=%@", BASE_URL, API_KEY, shoppingCenterId, userId, [self imageSize], [Utils currentLanguage]];
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            receive(data);
        }
        [Utils dismissAnimation];
    }];
    [urlConnection resume];
}

+(void) getItem:(int)itemid receive:(void (^)(NSData *data))receive {
    [Utils displayAnimation];
    
    NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
    int userId = [NSNumber numberWithInteger:[userDefaults integerForKey:@"userId"]].intValue;
    NSString *urlString = [NSString stringWithFormat:@"%@locations?api_key=%@&location_ids=%d&user_id=%d&size=%@&lang=%@", BASE_URL, API_KEY, itemid, userId, [self imageSize], [Utils currentLanguage]];
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            receive(data);
        }
        [Utils dismissAnimation];
    }];
    [urlConnection resume];
}

+(void) getPins:(CLLocationCoordinate2D)location withFilters:(NSString *)filters receive:(void (^)(NSData *data))receive {
    NSString *urlString = [NSString stringWithFormat:@"%@locations/pins?api_key=%@", BASE_URL, API_KEY];
    if(CLLocationCoordinate2DIsValid(location)) {
        urlString = [urlString stringByAppendingFormat:@"&lat=%f&lng=%f", location.latitude, location.longitude];
    }
    if(![filters isEqualToString:@""]) {
        urlString = [urlString stringByAppendingFormat:@"&category_id=%@", filters];
    }
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        receive(data);
    }];
    [urlConnection resume];
}

+(void) getPin:(int)locationId withLanguage:(NSString *)language receive:(void (^)(NSDictionary *dictionary))receive {
    long userId = [[NSUserDefaults standardUserDefaults] integerForKey:@"userId"];
    NSString *urlString = [NSString stringWithFormat:@"%@locations/pin?api_key=%@&location_ids=%d&user_id=%lu&lang=%@", BASE_URL, API_KEY, locationId, userId, language];
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            receive([NSJSONSerialization JSONObjectWithData:data options:0 error:&error]);
        }
    }];
    [urlConnection resume];
}

+(void) getNotifications:(void (^)(long newNotifications))receive {
    long userId = [[NSUserDefaults standardUserDefaults] integerForKey:@"userId"];
    NSString *urlString = [NSString stringWithFormat:@"%@inbox?api_key=%@&user_id=%lu&lang=%@&size=%@", BASE_URL, API_KEY, userId, [Utils currentLanguage], [self imageSize]];
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(data != nil) {
            NSManagedObjectContext *managedObjectContext = ((AppDelegate *)[UIApplication sharedApplication].delegate).managedObjectContext;
            NSError *error;
            NSArray<NSDictionary *> *notificationsArray = (NSArray<NSDictionary *> *)[NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
            NSFetchRequest *request = [NSFetchRequest fetchRequestWithEntityName:@"Notification"];
            for(NSDictionary *notificationDictionary in notificationsArray) {
                request.predicate = [NSPredicate predicateWithFormat:@"notificationId == %d", [[notificationDictionary objectForKey:@"id"] intValue]];
                NSArray<Notification *> *savedNotificationsArray = [managedObjectContext executeFetchRequest:request error:&error];
                if(savedNotificationsArray.count == 0) {
                    Notification *notification = (Notification *)[NSEntityDescription insertNewObjectForEntityForName:@"Notification" inManagedObjectContext:managedObjectContext];
                    notification.notificationId = [notificationDictionary objectForKey:@"id"];
                    notification.notificationObject = [notificationDictionary objectForKey:@"object"];
                    notification.notificationObjectId = [notificationDictionary objectForKey:@"object_id"];
                    notification.notificationName = [notificationDictionary objectForKey:@"name"];
                    if([notificationDictionary objectForKey:@"brand"]) {
                        notification.notificationBrand = [notificationDictionary objectForKey:@"brand"];
                    } else {
                        notification.notificationBrand = [NSNumber numberWithInt:-1];
                    }
                    if([notificationDictionary objectForKey:@"title"]) {
                        notification.notificationTitle = [notificationDictionary objectForKey:@"title"];
                    } else {
                        notification.notificationTitle = @"";
                    }
                    if([notificationDictionary objectForKey:@"start_at"]) {
                        notification.notificationStart = [notificationDictionary objectForKey:@"start_at"];
                    } else {
                        notification.notificationStart = @"";
                    }
                    if([notificationDictionary objectForKey:@"end_at"]) {
                        notification.notificationEnd = [notificationDictionary objectForKey:@"end_at"];
                    } else {
                        notification.notificationEnd = @"";
                    }
                    if([notificationDictionary objectForKey:@"content"]) {
                        notification.notificationContent = [notificationDictionary objectForKey:@"content"];
                    } else {
                        notification.notificationContent = @"";
                    }
                    if([notificationDictionary objectForKey:@"image"]) {
                        notification.notificationImage = [notificationDictionary objectForKey:@"image"];
                    } else {
                        notification.notificationImage = @"";
                    }
                    if([notificationDictionary objectForKey:@"notification"]) {
                        notification.notificationDescription = [notificationDictionary objectForKey:@"notification"];
                    } else {
                        notification.notificationDescription = @"";
                    }
                    notification.notificationIsRead = [NSNumber numberWithInt:0];
                } else if(savedNotificationsArray.count == 1) {
                    Notification *notification = (Notification *)[savedNotificationsArray objectAtIndex:0];
                    notification.notificationObject = [notificationDictionary objectForKey:@"object"];
                    notification.notificationObjectId = [notificationDictionary objectForKey:@"object_id"];
                    notification.notificationName = [notificationDictionary objectForKey:@"name"];
                    if([notificationDictionary objectForKey:@"brand"]) {
                        notification.notificationBrand = [notificationDictionary objectForKey:@"brand"];
                    } else {
                        notification.notificationBrand = [NSNumber numberWithInt:-1];
                    }
                    if([notificationDictionary objectForKey:@"title"]) {
                        notification.notificationTitle = [notificationDictionary objectForKey:@"title"];
                    } else {
                        notification.notificationTitle = @"";
                    }
                    if([notificationDictionary objectForKey:@"start_at"]) {
                        notification.notificationStart = [notificationDictionary objectForKey:@"start_at"];
                    } else {
                        notification.notificationStart = @"";
                    }
                    if([notificationDictionary objectForKey:@"end_at"]) {
                        notification.notificationEnd = [notificationDictionary objectForKey:@"end_at"];
                    } else {
                        notification.notificationEnd = @"";
                    }
                    if([notificationDictionary objectForKey:@"content"]) {
                        notification.notificationContent = [notificationDictionary objectForKey:@"content"];
                    } else {
                        notification.notificationContent = @"";
                    }
                    if([notificationDictionary objectForKey:@"image"]) {
                        notification.notificationImage = [notificationDictionary objectForKey:@"image"];
                    } else {
                        notification.notificationImage = @"";
                    }
                    if([notificationDictionary objectForKey:@"notification"]) {
                        notification.notificationDescription = [notificationDictionary objectForKey:@"notification"];
                    } else {
                        notification.notificationDescription = @"";
                    }
                }
            }
            [((AppDelegate *)[UIApplication sharedApplication].delegate) saveContext];
            request.predicate = [NSPredicate predicateWithFormat:@"notificationIsRead == %d", 0];
            NSArray<Notification *> *unreadNotifications = [managedObjectContext executeFetchRequest:request error:&error];
            receive(unreadNotifications.count);
        }
    }];
    [urlConnection resume];

}

+(void) followPlace:(int)hasToFollow withLocationId:(int)locationId receive:(void (^)(BOOL success))receive {
    long userId = [[NSUserDefaults standardUserDefaults] integerForKey:@"userId"];
    NSString *follow = nil;
    if(hasToFollow == 1) {
        follow = @"unfollow";
    } else {
        follow = @"follow";
    }
    NSString *urlString = [NSString stringWithFormat:@"%@location/%@?api_key=%@&location_id=%d&user_id=%lu", BASE_URL, follow, API_KEY, locationId, userId];
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
        if([dict objectForKey:@"LocationFollowRelationId"] || [dict objectForKey:@"deleted"]) {
            receive(YES);
        } else {
            receive(NO);
        }
    }];
    [urlConnection resume];
}

+(void) followBrand:(int)hasToFollow withLocationId:(int)locationId receive:(void (^)(BOOL success))receive {
    long userId = [[NSUserDefaults standardUserDefaults] integerForKey:@"userId"];
    NSString *follow = nil;
    if(hasToFollow == 1) {
        follow = @"unfollow";
    } else {
        follow = @"follow";
    }
    NSString *urlString = [NSString stringWithFormat:@"%@brand/%@?api_key=%@&brand_id=%d&user_id=%lu", BASE_URL, follow, API_KEY, locationId, userId];
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
        if([dict objectForKey:@"BrandFollowRelationId"] || [dict objectForKey:@"deleted"]) {
            receive(YES);
        } else {
            receive(NO);
        }
    }];
    [urlConnection resume];
}

+(void) sendFeedBack:(NSString *)phone email:(NSString *)email message:(NSString *)message {
    long userId = [[NSUserDefaults standardUserDefaults] integerForKey:@"userId"];
    NSString *urlString = [NSString stringWithFormat:@"%@user/feedback?api_key=%@&lang=%@&user_id=%lu&phone=%@&email=%@&message=%@", BASE_URL, API_KEY, [Utils currentLanguage], userId, phone, email, message];
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionConfiguration* configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession* urlSession = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLSessionDataTask *urlConnection = [urlSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        
    }];
    [urlConnection resume];

}

+(NSString *)imageSize {
    switch ((int)[UIScreen mainScreen].scale) {
        case 2: {
            return @"s";
        }
            
        case 3: {
            return @"m";
        }
            
        case 4: {
            return @"l";
        }
            
        default:
            return @"";
    }
}

+(void)checkImagesFolderSize {
    NSError *error;
    NSFileManager *fileManager = [NSFileManager defaultManager];
    NSURL *folderURL = [fileManager URLForDirectory:NSDocumentDirectory inDomain:NSUserDomainMask appropriateForURL:nil create:NO error:&error];
    folderURL = [folderURL URLByAppendingPathComponent:@"images"];
    NSDictionary *images = [fileManager attributesOfItemAtPath:folderURL.path error:&error];
    NSNumber *fileSizeNumber = [images objectForKey:NSFileSize];
    long long size = [fileSizeNumber longLongValue] / 1024;
    if(size > 50) {
        NSDate *initialDate = [NSDate date];
        NSFileManager *fileManager = [NSFileManager defaultManager];
        NSDirectoryEnumerator *dirEnumerator = [fileManager enumeratorAtURL:folderURL includingPropertiesForKeys:@[NSURLCreationDateKey]                                                        options:NSDirectoryEnumerationSkipsHiddenFiles | NSDirectoryEnumerationSkipsSubdirectoryDescendants errorHandler:nil];
        
        for (NSURL *url in dirEnumerator) {
            NSDate *creationDate;
            [url getResourceValue:&creationDate forKey:NSURLCreationDateKey error:&error];
            if([initialDate compare:creationDate] == NSOrderedDescending) {
                initialDate = creationDate;
            }
        }
        
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        dateFormatter.dateFormat = @"dd.MM.yyyy";
        NSString *initial = [dateFormatter stringFromDate:initialDate];
        dirEnumerator = [fileManager enumeratorAtURL:folderURL includingPropertiesForKeys:@[NSURLCreationDateKey]                                                        options:NSDirectoryEnumerationSkipsHiddenFiles | NSDirectoryEnumerationSkipsSubdirectoryDescendants errorHandler:nil];
        NSMutableArray<NSURL *> *urlsToDelete = [[NSMutableArray alloc] initWithCapacity:0];
        for(NSURL *url in dirEnumerator) {
            NSDate *creationDate;
            [url getResourceValue:&creationDate forKey:NSURLCreationDateKey error:&error];
            NSString *creation = [dateFormatter stringFromDate:creationDate];
            if([creation isEqualToString:initial]) {
                [urlsToDelete addObject:url];
                [fileManager removeItemAtURL:url error:&error];
            }
        }
        
        for(NSURL *url in urlsToDelete) {
            NSNumber *temp;
            BOOL isDirectory = [url getResourceValue:&temp forKey:NSURLIsDirectoryKey error:nil];
            if(!isDirectory) {
                [fileManager removeItemAtURL:url error:&error];
            }
        }
        urlsToDelete = nil;
    }
}

@end
