//
//  BlueWebViewController.m
//  plus
//
//  Created by Виктор Георгиев on 8/13/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "WebViewController.h"

#import "Utils.h"

@interface WebViewController ()

@property (weak, nonatomic) IBOutlet UIButton *backButton;

@end

@implementation WebViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.webView.scrollView.bounces = NO;
    [self.webView loadRequest:self.request];    
    
    if(self.isFromMainDrawer) {
        self.backButton.userInteractionEnabled = NO;
    }
}

-(void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    if(!self.isFromMainDrawer) {
        CGRect rect = self.backButton.bounds;
        UIBezierPath *maskPath = [UIBezierPath bezierPathWithRoundedRect:rect byRoundingCorners:UIRectCornerTopRight cornerRadii:CGSizeMake(10, 10)];
        CAShapeLayer *maskLayer = [CAShapeLayer layer];
        maskLayer.fillColor = [Utils colorFromHexString:@"#46ADC6"].CGColor;
        maskLayer.frame = rect;
        maskLayer.path = maskPath.CGPath;
        [self.backButton.layer insertSublayer:maskLayer atIndex:0];
        self.backButton.hidden = NO;
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (IBAction)onBackPressed:(id)sender {
    [self.navigationController popViewControllerAnimated:YES];
    if(self.onDismiss != nil) {
        self.onDismiss();
    }

}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
